import React from 'react';
import { action } from '@storybook/addon-actions';
import { createComponentStory } from 'stories';

import AutoComplete from './index';

const story = createComponentStory({ component: AutoComplete });

story.addWithDoc('AutoComplete', ({ props }) => (
  <AutoComplete
    customNormalize={value => value.replace(/[a-zA-Z]/g, '')}
    input={{ onChange: action('onChange'), value: 'ua' }}
    onQueryChange={action('onQueryChange')}
    list={[
      {
        value: 'ua',
        label: 'Ukraine'
      },
      {
        value: 'usa',
        label: 'USA',
      },
      {
        value: 'de',
        label: 'Germany',
      },
      {
        value: 'pl',
        label: 'Poland'
      },
      {
        value: 'fr',
        label: 'France',
      },
      {
        value: 'it',
        label: 'Italy',
      }
    ]}
    label="Select country"
    {...props}
  />
), AutoComplete, {
  defaultProps: {}
});
