import React from 'react';
import PropTypes from 'prop-types';
import bemDecorator from 'cn-decorator';

import _uah from './images/uah.svg';
import _dsd from './images/dsd.svg';
import _amd from './images/amd.svg';
import _aud from './images/aud.svg';
import _azn from './images/azn.svg';
import _bdt from './images/bdt.svg';
import _byn from './images/byn.svg';
import _bgn from './images/bgn.svg';
import _cad from './images/cad.svg';
import _clp from './images/clp.svg';
import _cny from './images/cny.svg';
import _hrk from './images/hrk.svg';
import _czk from './images/czk.svg';
import _dkk from './images/dkk.svg';
import _egp from './images/egp.svg';
import _eur from './images/eur.svg';
import _hkd from './images/hkd.svg';
import _huf from './images/huf.svg';
import _isk from './images/isk.svg';
import _inr from './images/inr.svg';
import _idr from './images/idr.svg';
import _irr from './images/irr.svg';
import _iqd from './images/iqd.svg';
import _jpy from './images/jpy.svg';
import _kzt from './images/kzt.svg';
import _kwd from './images/kwd.svg';
import _kgs from './images/kgs.svg';
import _lbp from './images/lbp.svg';
import _lyd from './images/lyd.svg';
import _myr from './images/myr.svg';
import _mxn from './images/mxn.svg';
import _mdl from './images/mdl.svg';
import _mnt from './images/mnt.svg';
import _mad from './images/mad.svg';
import _nok from './images/nok.svg';
import _pkr from './images/pkr.svg';
import _pen from './images/pen.svg';
import _pln from './images/pln.svg';
import _ron from './images/ron.svg';
import _rub from './images/rub.svg';
import _sar from './images/sar.svg';
import _rsd from './images/rsd.svg';
import _sgd from './images/sgd.svg';
import _zar from './images/zar.svg';
import _krw from './images/krw.svg';
import _sek from './images/sek.svg';
import _chf from './images/chf.svg';
import _syp from './images/syp.svg';
import _twd from './images/twd.svg';
import _tjs from './images/tjs.svg';
import _thb from './images/thb.svg';
import _tnd from './images/tnd.svg';
import _try from './images/try.svg';
import _tmt from './images/tmt.svg';
import _aed from './images/aed.svg';
import _gbp from './images/gbp.svg';
import _usd from './images/usd.svg';
import _uzs from './images/uzs.svg';
import _vnd from './images/vnd.svg';

import './index.scss';

const IMAGES = {
  'uah': _uah,
  'dsd': _dsd,
  'amd': _amd,
  'aud': _aud,
  'azn': _azn,
  'bdt': _bdt,
  'byn': _byn,
  'bgn': _bgn,
  'cad': _cad,
  'clp': _clp,
  'cny': _cny,
  'hrk': _hrk,
  'czk': _czk,
  'dkk': _dkk,
  'egp': _egp,
  'eur': _eur,
  'hkd': _hkd,
  'huf': _huf,
  'isk': _isk,
  'inr': _inr,
  'idr': _idr,
  'irr': _irr,
  'iqd': _iqd,
  'jpy': _jpy,
  'kzt': _kzt,
  'kwd': _kwd,
  'kgs': _kgs,
  'lbp': _lbp,
  'lyd': _lyd,
  'myr': _myr,
  'mxn': _mxn,
  'mdl': _mdl,
  'mnt': _mnt,
  'mad': _mad,
  'nok': _nok,
  'pkr': _pkr,
  'pen': _pen,
  'pln': _pln,
  'ron': _ron,
  'rub': _rub,
  'sar': _sar,
  'rsd': _rsd,
  'sgd': _sgd,
  'zar': _zar,
  'krw': _krw,
  'sek': _sek,
  'chf': _chf,
  'syp': _syp,
  'twd': _twd,
  'tjs': _tjs,
  'thb': _thb,
  'tnd': _tnd,
  'try': _try,
  'tmt': _tmt,
  'aed': _aed,
  'gbp': _gbp,
  'usd': _usd,
  'uzs': _uzs,
  'vnd': _vnd,
};

/**
 * ## Usage
 *
 * ```javascript
 * import CurrencyFlag from '@Components/CurrencyFlag';
 *
 * export default class {
 *   render() {
 *     return (
 *       <CurrencyFlag currency="usd" theme="your-custom-theme" />
 *     );
 *   }
 * }
 * ```
 */
@bemDecorator('currency-flag')
export default class CurrencyFlag extends React.PureComponent {
  static displayName = 'CurrencyFlag';

  static propTypes = {
    currency: PropTypes.oneOf(['uah', 'dsd', 'amd', 'aud', 'azn', 'bdt', 'byn', 'bgn', 'cad', 'clp', 'cny', 'hrk', 'czk', 'dkk', 'egp', 'eur', 'hkd', 'huf', 'isk', 'inr', 'idr', 'irr', 'iqd', 'jpy', 'kzt', 'kwd', 'kgs', 'lbp', 'lyd', 'myr', 'mxn', 'mdl', 'mnt', 'mad', 'nok', 'pkr', 'pen', 'pln', 'ron', 'rub', 'sar', 'rsd', 'sgd', 'zar', 'krw', 'sek', 'chf', 'syp', 'twd', 'tjs', 'thb', 'tnd', 'try', 'tmt', 'aed', 'gbp', 'usd', 'uzs', 'vnd']),
    theme: PropTypes.oneOf(['default', 'cover']),
    size: PropTypes.number,
    inherit: PropTypes.bool,
  };

  static defaultProps = {
    currency: 'uah',
    theme: 'default',
    size: 60,
    inherit: false,
  };

  render(bem) {
    const { currency, theme, size, inherit } = this.props;

    return (
      <img
        className={bem({ theme, inherit })}
        style={{
          width: inherit ? 'inherit' : size,
          height: inherit ? 'inherit' : size,
        }}
        src={IMAGES[currency]}
        alt={currency}
      />
    );
  }
}
