import React from 'react';
import { action } from '@storybook/addon-actions';
import { createComponentStory } from 'stories';

import CustomDateRangePicker, { DateRangePicker } from './index';

const story = createComponentStory({ component: DateRangePicker });

story.addWithDoc('DateRangePicker', ({ props }) => (
  <div>
    <CustomDateRangePicker
      {...props}
      input={{
        onChange: action('onChange'),
        onFocus: action('onFocus'),
        value: { start: '1516658400000', end: '1516658400000' },
      }}
      helperText="345678jn,"
      meta={{
        // error: "fjdshfkjhsad",
        // touched: true,
      }}
    />
  </div>
), DateRangePicker, {
  defaultProps: {
    children: 'Default button',
    label: 'DatePicker',
    helperText: '345678jn,',
    theme: 'default'
  },
});
