import React from 'react';

import { createComponentStory } from 'stories';

import Icon, { ICONS } from './index';

const story = createComponentStory({ component: Icon });

story.addWithDoc('Default icon', ({ props }) => (
  <Icon {...props} />
), Icon, {
  defaultProps: {
    name: 'add'
  }
});

story.addWithDoc('List of icons', ({ props }) => (
  <ul className="icons-list">
    {
      ICONS.map(name => (
        <li className="icons-list__item" key={name}>
          <Icon {...props} name={name} />
          <span>{name}</span>
        </li>
      ))
    }
  </ul>
), Icon, {
  defaultProps: {
    size: 48
  }
});
