const SHOW_MODAL = '@modal/SHOW';
const HIDE_MODAL = '@modal/HIDE';
const HIDE_ALL_MODAL = '@modal/HIDE_ALL';

export const showModal = (name, options) => ({
  type: SHOW_MODAL,
  payload: { name, options },
});

export const hideModal = name => ({
  type: HIDE_MODAL,
  payload: { name },
});

export const hideAllModal = () => ({
  type: HIDE_ALL_MODAL,
  payload: null,
});

export default (state = {}, action) => {
  switch (action.type) {
    case SHOW_MODAL:
      return {
        ...state,
        [action.payload.name]: {
          show: true,
          ...action.payload,
        },
      };
    case HIDE_MODAL:
      return {
        ...state,
        [action.payload.name]: null,
      };
    case HIDE_ALL_MODAL:
      return {};
    default:
      return state;
  }
};
