import React from 'react';
import { createComponentStory } from 'stories';

import MultiTabs from './index';

const story = createComponentStory({ component: MultiTabs });

const tabs = [
  1,
  2,
  {
    label: 3,
    disabled: true,
  },
  4,
  5,
  {
    label: (<span style={{ color: 'red' }}>6</span>),
  },
  7,
  8,
  9,
  10,
  11,
  12,
  13,
];

story.addWithDoc('MultiTabs', ({ props }) => (
  <MultiTabs
    {...props}
    tabs={tabs}
  >
    {tabs.map(tab => (
      <div>{tab.label || tab}</div>
    ))}
  </MultiTabs>
));
