import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';

import './index.scss';

export default class PasswordEye extends React.PureComponent {
  static displayName = 'PasswordEye';

  static propTypes = {
    onChange: PropTypes.func,
    type: PropTypes.string,
  };

  static defaultProps = {
    onChange: () => {},
    type: '',
  };

  onClickHandler() {
    this.props.onChange(this.isParentPassword() ? 'text' : 'password');
  }

  isParentPassword() {
    return this.props.type === 'password';
  }

  render() {
    return (
      <div // eslint-disable-line
        className={classNames('password-eye', { active: !this.isParentPassword() })}
        onClick={() => this.onClickHandler()}
      />
    );
  }
}
