import React from 'react';
import PropTypes from 'prop-types';

import './index.scss';

export default class PasswordHints extends React.PureComponent {
  static displayName = 'PasswordHints';

  static propTypes = {
    hints: PropTypes.arrayOf(PropTypes.string),
  };

  static defaultProps = {
    hints: [],
  };

  render() {
    const { hints } = this.props;
    return (
      <div className="hint-wrapper">
        <div className="hint-content">
          {hints.map((item, ind) => (
            <p key={ind} dangerouslySetInnerHTML={{ __html: item }} />  // eslint-disable-line
          ))}
        </div>
      </div>
    );
  }
}
