import React from 'react';
import PropTypes from 'prop-types';
import {
  TableFooter,
  TablePagination,
  TableRow,
} from 'material-ui/Table';

export default class Footer extends React.Component {
  static displayName = 'Footer';

  static propTypes = {
    colSpan: PropTypes.number.isRequired,
    count: PropTypes.number.isRequired,
    labelRowsPerPage: PropTypes.string.isRequired,
    rowsPerPage: PropTypes.number.isRequired,
    rowsPerPageOptions: PropTypes.array.isRequired,
    page: PropTypes.number.isRequired,
    onChangeRowsPerPage: PropTypes.func.isRequired,
    onChangePage: PropTypes.func.isRequired,
  };

  render() {
    const {
      colSpan, count, rowsPerPage, rowsPerPageOptions, page,
      onChangePage, onChangeRowsPerPage, labelRowsPerPage,
    } = this.props;

    return (
      <TableFooter>
        <TableRow>
          <TablePagination
            colSpan={colSpan}
            count={count}
            rowsPerPage={rowsPerPage}
            rowsPerPageOptions={rowsPerPageOptions}
            page={page}
            onChangePage={onChangePage}
            onChangeRowsPerPage={onChangeRowsPerPage}
            labelRowsPerPage={labelRowsPerPage}
            labelDisplayedRows={props => `${props.from} - ${props.to} : ${props.count}`}
          />
        </TableRow>
      </TableFooter>
    );
  }
}
