import React from 'react';
import { createComponentStory } from 'stories';
import { action } from '@storybook/addon-actions';

import Table from './index';

const story = createComponentStory({ component: Table });

const data = [
  {
    date: '31.08.2017',
    counterpartyName: 'ООО Ромашка',
    details: 'за вогнегасники',
    amount: 9216,
    timestamp: 1504135260,
    time: '02:21',
    meta: {
      id: 1,
      checked: false,
      visible: true,
    }
  },
  {
    date: '22.08.2017',
    counterpartyName: 'ООО Ромашка',
    details: 'сплата за обладнання',
    amount: 345,
    timestamp: 1503362164,
    time: '03:36',
    meta: {
      id: 2,
      checked: false,
      visible: true,
    }
  },
  {
    date: '04.08.2017',
    counterpartyName: 'ООО Ветер',
    details: 'нарахування',
    amount: 3348,
    timestamp: 1501802525,
    time: '02:22',
    meta: {
      id: 3,
      checked: false,
      visible: true,
    }
  },
  {
    date: '02.06.2017',
    counterpartyName: 'ООО Ромашка',
    details: 'перерахування власних коштів',
    amount: 9635,
    timestamp: 1496391708,
    time: '11:21',
    meta: {
      id: 4,
      checked: false,
      visible: true,
    }
  },
  {
    date: '28.04.2017',
    counterpartyName: 'ООО Ветер',
    details: 'за вогнегасники',
    amount: 100000,
    timestamp: 1493344804,
    time: '05:00',
    meta: {
      id: 5,
      checked: false,
      visible: true,
    }
  },
  {
    date: '31.08.2017',
    counterpartyName: 'ООО Ромашка',
    details: 'за вогнегасники',
    amount: 9216,
    timestamp: 1504135260,
    time: '02:21',
    meta: {
      id: 6,
      checked: false,
      visible: true,
    }
  },
  {
    date: '22.08.2017',
    counterpartyName: 'ООО Ромашка',
    details: 'сплата за обладнання',
    amount: 345,
    timestamp: 1503362164,
    time: '03:36',
    meta: {
      id: 7,
      checked: false,
      visible: true,
    }
  },
  {
    date: '04.08.2017',
    counterpartyName: 'ООО Ветер',
    details: 'нарахування',
    amount: 3348,
    timestamp: 1501802525,
    time: '02:22',
    meta: {
      id: 8,
      checked: false,
      visible: true,
    }
  },
  {
    date: '02.06.2017',
    counterpartyName: 'ООО Ромашка',
    details: 'перерахування власних коштів',
    amount: 9635,
    timestamp: 1496391708,
    time: '11:21',
    meta: {
      id: 9,
      checked: false,
      visible: true,
    }
  },
  {
    date: '28.04.2017',
    counterpartyName: 'ООО Ветер',
    details: 'за вогнегасники',
    amount: 100000,
    timestamp: 1493344804,
    time: '05:00',
    meta: {
      id: 10,
      checked: false,
      visible: true,
    }
  },
  {
    date: '31.08.2017',
    counterpartyName: 'ООО Ромашка',
    details: 'за вогнегасники',
    amount: 9216,
    timestamp: 1504135260,
    time: '02:21',
    meta: {
      id: 11,
      checked: false,
      visible: true,
    }
  },
  {
    date: '22.08.2017',
    counterpartyName: 'ООО Ромашка',
    details: 'сплата за обладнання',
    amount: 345,
    timestamp: 1503362164,
    time: '03:36',
    meta: {
      id: 12,
      checked: false,
      visible: true,
    }
  },
  {
    date: '04.08.2017',
    counterpartyName: 'ООО Ветер',
    details: 'нарахування',
    amount: 3348,
    timestamp: 1501802525,
    time: '02:22',
    meta: {
      id: 13,
      checked: false,
      visible: true,
    }
  },
  {
    date: '02.06.2017',
    counterpartyName: 'ООО Ромашка',
    details: 'перерахування власних коштів',
    amount: 9635,
    timestamp: 1496391708,
    time: '11:21',
    meta: {
      id: 14,
      checked: false,
      visible: true,
    }
  },
  {
    date: '28.04.2017',
    counterpartyName: 'ООО Ветер',
    details: 'за вогнегасники',
    amount: 100000,
    timestamp: 1493344804,
    time: '05:00',
    meta: {
      id: 15,
      checked: false,
      visible: true,
    }
  },
  {
    date: '31.08.2017',
    counterpartyName: 'ООО Ромашка',
    details: 'за вогнегасники',
    amount: 9216,
    timestamp: 1504135260,
    time: '02:21',
    meta: {
      id: 16,
      checked: false,
      visible: true,
    }
  },
  {
    date: '22.08.2017',
    counterpartyName: 'ООО Ромашка',
    details: 'сплата за обладнання',
    amount: 345,
    timestamp: 1503362164,
    time: '03:36',
    meta: {
      id: 17,
      checked: false,
      visible: true,
    }
  },
  {
    date: '04.08.2017',
    counterpartyName: 'ООО Ветер',
    details: 'нарахування',
    amount: 3348,
    timestamp: 1501802525,
    time: '02:22',
    meta: {
      id: 18,
      checked: false,
      visible: true,
    }
  },
  {
    date: '02.06.2017',
    counterpartyName: 'ООО Ромашка',
    details: 'перерахування власних коштів',
    amount: 9635,
    timestamp: 1496391708,
    time: '11:21',
    meta: {
      id: 19,
      checked: false,
      visible: true,
    }
  },
  {
    date: '28.04.2017',
    counterpartyName: 'ООО Ветер',
    details: 'за вогнегасники',
    amount: 100000,
    timestamp: 1493344804,
    time: '05:00',
    meta: {
      id: 20,
      checked: false,
      visible: true,
    }
  },
  {
    date: '31.08.2017',
    counterpartyName: 'ООО Ромашка',
    details: 'за вогнегасники',
    amount: 9216,
    timestamp: 1504135260,
    time: '02:21',
    meta: {
      id: 21,
      checked: false,
      visible: true,
    }
  },
  {
    date: '22.08.2017',
    counterpartyName: 'ООО Ромашка',
    details: 'сплата за обладнання',
    amount: 345,
    timestamp: 1503362164,
    time: '03:36',
    meta: {
      id: 22,
      checked: false,
      visible: true,
    }
  },
  {
    date: '04.08.2017',
    counterpartyName: 'ООО Ветер',
    details: 'нарахування',
    amount: 3348,
    timestamp: 1501802525,
    time: '02:22',
    meta: {
      id: 23,
      checked: false,
      visible: true,
    }
  },
  {
    date: '02.06.2017',
    counterpartyName: 'ООО Ромашка',
    details: 'перерахування власних коштів',
    amount: 9635,
    timestamp: 1496391708,
    time: '11:21',
    meta: {
      id: 24,
      checked: false,
      visible: true,
    }
  },
  {
    date: '28.04.2017',
    counterpartyName: 'ООО Ветер',
    details: 'за вогнегасники',
    amount: 100000,
    timestamp: 1493344804,
    time: '05:00',
    meta: {
      id: 25,
      checked: false,
      visible: true,
    }
  },
  {
    date: '31.08.2017',
    counterpartyName: 'ООО Ромашка',
    details: 'за вогнегасники',
    amount: 9216,
    timestamp: 1504135260,
    time: '02:21',
    meta: {
      id: 26,
      checked: false,
      visible: true,
    }
  },
  {
    date: '22.08.2017',
    counterpartyName: 'ООО Ромашка',
    details: 'сплата за обладнання',
    amount: 345,
    timestamp: 1503362164,
    time: '03:36',
    meta: {
      id: 27,
      checked: false,
      visible: true,
    }
  },
  {
    date: '04.08.2017',
    counterpartyName: 'ООО Ветер',
    details: 'нарахування',
    amount: 3348,
    timestamp: 1501802525,
    time: '02:22',
    meta: {
      id: 28,
      checked: false,
      visible: true,
    }
  },
  {
    date: '02.06.2017',
    counterpartyName: 'ООО Ромашка',
    details: 'перерахування власних коштів',
    amount: 9635,
    timestamp: 1496391708,
    time: '11:21',
    meta: {
      id: 29,
      checked: false,
      visible: true,
    }
  },
  {
    date: '28.04.2017',
    counterpartyName: 'ООО Ветер',
    details: 'за вогнегасники',
    amount: 100000,
    timestamp: 1493344804,
    time: '05:00',
    meta: {
      id: 30,
      checked: false,
      visible: true,
    }
  },
  {
    date: '31.08.2017',
    counterpartyName: 'ООО Ромашка',
    details: 'за вогнегасники',
    amount: 9216,
    timestamp: 1504135260,
    time: '02:21',
    meta: {
      id: 31,
      checked: false,
      visible: true,
    }
  },
  {
    date: '22.08.2017',
    counterpartyName: 'ООО Ромашка',
    details: 'сплата за обладнання',
    amount: 345,
    timestamp: 1503362164,
    time: '03:36',
    meta: {
      id: 32,
      checked: false,
      visible: true,
    }
  },
  {
    date: '04.08.2017',
    counterpartyName: 'ООО Ветер',
    details: 'нарахування',
    amount: 3348,
    timestamp: 1501802525,
    time: '02:22',
    meta: {
      id: 33,
      checked: false,
      visible: true,
    }
  },
  {
    date: '02.06.2017',
    counterpartyName: 'ООО Ромашка',
    details: 'перерахування власних коштів',
    amount: 9635,
    timestamp: 1496391708,
    time: '11:21',
    meta: {
      id: 34,
      checked: false,
      visible: true,
    }
  },
  {
    date: '28.04.2017',
    counterpartyName: 'ООО Ветер',
    details: 'за вогнегасники',
    amount: 100000,
    timestamp: 1493344804,
    time: '05:00',
    meta: {
      id: 35,
      checked: false,
      visible: true,
    }
  },
  {
    date: '31.08.2017',
    counterpartyName: 'ООО Ромашка',
    details: 'за вогнегасники',
    amount: 9216,
    timestamp: 1504135260,
    time: '02:21',
    meta: {
      id: 36,
      checked: false,
      visible: true,
    }
  },
  {
    date: '22.08.2017',
    counterpartyName: 'ООО Ромашка',
    details: 'сплата за обладнання',
    amount: 345,
    timestamp: 1503362164,
    time: '03:36',
    meta: {
      id: 37,
      checked: false,
      visible: true,
    }
  },
  {
    date: '04.08.2017',
    counterpartyName: 'ООО Ветер',
    details: 'нарахування',
    amount: 3348,
    timestamp: 1501802525,
    time: '02:22',
    meta: {
      id: 38,
      checked: false,
      visible: true,
    }
  },
  {
    date: '02.06.2017',
    counterpartyName: 'ООО Ромашка',
    details: 'перерахування власних коштів',
    amount: 9635,
    timestamp: 1496391708,
    time: '11:21',
    meta: {
      id: 39,
      checked: false,
      visible: true,
    }
  },
  {
    date: '28.04.2017',
    counterpartyName: 'ООО Ветер',
    details: 'за вогнегасники',
    amount: 100000,
    timestamp: 1493344804,
    time: '05:00',
    meta: {
      id: 40,
      checked: false,
      visible: true,
    }
  }
];

story.addWithDoc('Table', ({ props }) => (
  <Table
    {...props}
    sticky
    name="myTable"
    labelRowsPerPage="Транзакцій на сторінку"
    labelChosen="обрано"
    labelNoSearchResult="Збігів не знайдено"
    mainLabel="Виписка за рахунком"
    withCheckboxes
    withHover
    withSort
    fixed
    rowsPerPage={5}
    defaultOrderBy="details"
    rowsPerPageOptions={[2, 3, 5]}
    keysForSearch={['details', 'counterpartyName']}
    columnData={[{
        id: 'date',
        label: 'ДАТА',
        orderBy: 'timestamp',
      }, {
        id: 'amount',
        label: 'СУМА',
        alignRight: true,
        orderBy: 'amount',
      }, {
        id: 'counterpartyName',
        label: 'КОНТРАГЕНТ',
      }, {
        id: 'details',
        label: 'ПРИЗНАЧЕННЯ',
        orderBy: 'details',
      }]}
    rowData={data.map(item => ({
      date: (
        <div>
          <div>{item.date}</div>
          <div>{item.time}</div>
        </div>
      ),
      amount: item.amount,
      counterpartyName: item.counterpartyName,
      details: item.details,
      meta: item.meta,
    }))}
    onChangeRowsPerPage={action('onChangeRowsPerPage')}
    onChangePage={action('onChangePage')}
    onChangeSort={action('onChangeSort')}
    onRowClick={action('onRowClick')}
    onSelectAll={action('onSelectAll')}
    onSelectOne={action('onSelectOne')}
  />
), Table, {
  defaultProps: {
    withSort: true,
    withCheckboxes: false,
    defaultOrderBy: 'details',
    order: 'asc',
    sticky: true,
    name: 'myTable',
  }
});
