import React from 'react';
import { createComponentStory } from 'stories';

import TextInput from './index';

const story = createComponentStory({ component: TextInput });

story.addWithDoc('TextInput', ({ props }) => (
  <TextInput {...props} />
), TextInput, {
  defaultProps: {
    label: 'My input',
    loading: true,
  }
});

story.addWithDoc('Multi Line Input', ({ props }) => (
  <TextInput {...props} />
), TextInput, {
  defaultProps: {
    label: 'My input',
    multiline: true,
    rows: 2,
    rowsMax: 3,
  }
});
