import React from 'react';
import { createComponentStory } from 'stories';
import Divider from 'material-ui/Divider';

import Title from './index';

const story = createComponentStory({ component: Title });

story.addWithDoc('Title', ({ props }) => (
  <React.Fragment>
    <Title {...props} color="primary" align="center">Headers</Title>
    <Divider light />
    <Title heading={1}>
      Heading 1
    </Title>
    <Title heading={2}>
      Heading 2
    </Title>
    <Title heading={3}>
      Heading 3
    </Title>
    <Title heading={4}>
      Heading 4
    </Title>
    <Title heading={5}>
      Heading 5
    </Title>
    <Title heading={6} gutterBottom>
      Heading 6
    </Title>
    <Title {...props} color="primary" align="center">Displays</Title>
    <Divider light />
    <br />
    <Title display={1}>
      Display 1
    </Title>
    <Title display={2}>
      Display 2
    </Title>
    <Title display={3}>
      Display 3
    </Title>
    <Title gutterBottom display={4}>
      Display 4
    </Title>
    <Divider light />
    <Title heading={6} display={4} gutterBottom align="center">Счастье для всех, даром, и пусть никто не уйдет обиженным!</Title>
  </React.Fragment>
), Title, {
  defaultProps: {
    heading: 1,
  },
});
