'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Snackbar = require('material-ui/Snackbar');

var _Snackbar2 = _interopRequireDefault(_Snackbar);

var _Icon = require('../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

require('./index.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * ## Usage
 *
 * ```javascript
 * import AmountFormat from '@Components/Alert';
 *
 * export default class {
 *   render() {
 *     return (
 *       <Alert
 *          open
 *          type={"success"}
 *       >
 *       some text
 *       </Alert>
 *     );
 *   }
 * }
 * ```
 */
var Alert = function (_React$Component) {
  (0, _inherits3.default)(Alert, _React$Component);

  function Alert() {
    (0, _classCallCheck3.default)(this, Alert);
    return (0, _possibleConstructorReturn3.default)(this, (Alert.__proto__ || (0, _getPrototypeOf2.default)(Alert)).apply(this, arguments));
  }

  (0, _createClass3.default)(Alert, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          onClose = _props.onClose,
          onExit = _props.onExit,
          open = _props.open,
          timeout = _props.timeout;


      return _react2.default.createElement(_Snackbar2.default, {
        classes: { root: 'alert__wrapper-root' },
        anchorOrigin: { vertical: 'top', horizontal: 'left' },
        open: open,
        autoHideDuration: timeout,
        onClose: onClose,
        SnackbarContentProps: { 'aria-describedby': 'message-id', classes: { root: 'alert__root' } },
        message: _react2.default.createElement(
          'div',
          { className: 'alert__body' },
          _react2.default.createElement(
            'span',
            { className: 'alert__icon' },
            this.icon
          ),
          _react2.default.createElement(
            'p',
            { className: 'alert__message' },
            children
          )
        ),
        onExited: onExit,
        action: [_react2.default.createElement(
          'button',
          { key: 'button', className: 'alert__close-btn', onClick: onClose },
          _react2.default.createElement(_Icon2.default, { name: 'close', color: 'rgba(0,0,0,0.87)', size: Alert.IconSize })
        )]
      });
    }
  }, {
    key: 'icon',
    get: function get() {
      switch (this.props.type) {
        case 'success':
          return _react2.default.createElement(_Icon2.default, { name: 'check-round', color: 'green', size: 24 });
        case 'error':
          return _react2.default.createElement(_Icon2.default, { name: 'error', color: 'red', size: 28 });
        case 'warning':
          return _react2.default.createElement(_Icon2.default, { name: 'warning', color: '#FFC107', size: 24 });
        default:
          return null;
      }
    }
  }]);
  return Alert;
}(_react2.default.Component);

Alert.propTypes = {
  open: _propTypes2.default.bool, // eslint-disable-line
  type: _propTypes2.default.oneOf(['success', 'error', 'warning', false]),
  children: _propTypes2.default.any // eslint-disable-line
};
Alert.IconSize = 16;
Alert.defaultProps = {
  type: false
};
exports.default = Alert;