'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

require('./index.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var decomposeAmount = function decomposeAmount(amount) {
  return parseFloat(amount).toLocaleString('ru-RU', { maximumFractionDigits: 2, minimumFractionDigits: 2 }).toString().split(',');
};

/**
 * ## Usage
 *
 * ```javascript
 * import AmountFormat from '@Components/AmountFormat';
 *
 * export default class {
 *   render() {
 *     return (
 *       <AmountFormat
 *         amount={10.12}
 *         prefix={'$ '}
 *         theme="default" // by default, or you can use customTheme="your-custom-theme"
 *       />
 *     );
 *   }
 * }
 * ```
 */

var AmountFormat = function (_React$PureComponent) {
  (0, _inherits3.default)(AmountFormat, _React$PureComponent);

  function AmountFormat() {
    (0, _classCallCheck3.default)(this, AmountFormat);
    return (0, _possibleConstructorReturn3.default)(this, (AmountFormat.__proto__ || (0, _getPrototypeOf2.default)(AmountFormat)).apply(this, arguments));
  }

  (0, _createClass3.default)(AmountFormat, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          customTheme = _props.customTheme,
          theme = _props.theme,
          prefix = _props.prefix,
          suffix = _props.suffix,
          amount = _props.amount;

      var _decomposeAmount = decomposeAmount(amount),
          _decomposeAmount2 = (0, _slicedToArray3.default)(_decomposeAmount, 2),
          wholePart = _decomposeAmount2[0],
          fraction = _decomposeAmount2[1];

      return amount ? _react2.default.createElement(
        'span',
        { className: 'amount-format amount-format_theme_' + (customTheme || theme) },
        _react2.default.createElement(
          'span',
          { className: 'amount-format__prefix' },
          prefix
        ),
        ' ',
        _react2.default.createElement(
          'span',
          { className: 'amount-format__whole-part' },
          wholePart
        ),
        '.',
        _react2.default.createElement(
          'span',
          { className: 'amount-format__fraction' },
          fraction
        ),
        ' ',
        _react2.default.createElement(
          'span',
          { className: 'amount-format__suffix' },
          suffix
        )
      ) : _react2.default.createElement(
        'span',
        { className: 'amount-format amount-format_theme_' + (customTheme || theme) },
        _react2.default.createElement(
          'span',
          { className: 'amount-format__prefix' },
          prefix
        ),
        _react2.default.createElement(
          'span',
          { className: 'amount-format__empty' },
          ' \u2014 \u2014 . \u2014 \u2014 '
        ),
        _react2.default.createElement(
          'span',
          { className: 'amount-format__suffix' },
          suffix
        )
      );
    }
  }]);
  return AmountFormat;
}(_react2.default.PureComponent);

AmountFormat.displayName = 'AmountFormat';
AmountFormat.propTypes = {
  amount: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]).isRequired,
  prefix: _propTypes2.default.string,
  suffix: _propTypes2.default.string,
  customTheme: _propTypes2.default.string,
  theme: _propTypes2.default.oneOf(['default', 'bold', 'account-selector', 'statement-account-info', 'account-card-last-move', 'account-card-credit-limit', 'account-card-balance', 'payment-view-banner-amount', 'payment-view-banner-amount-blue', 'statement-table-amount', 'statement-table-amount_blue', 'default-table-amount'])
};
AmountFormat.defaultProps = {
  prefix: '',
  suffix: '',
  theme: 'default',
  customTheme: ''
};
exports.default = AmountFormat;