'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _cnDecorator = require('cn-decorator');

var _cnDecorator2 = _interopRequireDefault(_cnDecorator);

var _usd = require('../Icon/icons/usd.svg');

var _usd2 = _interopRequireDefault(_usd);

var _eur = require('../Icon/icons/eur.svg');

var _eur2 = _interopRequireDefault(_eur);

var _uah = require('../Icon/icons/uah.svg');

var _uah2 = _interopRequireDefault(_uah);

require('./index.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var CURRENCIES = { UAH: _uah2.default, EUR: _eur2.default, USD: _usd2.default };

var decomposeAmount = function decomposeAmount(amount) {
  return parseFloat(amount).toLocaleString('ru-RU', { maximumFractionDigits: 2, minimumFractionDigits: 2 }).toString().split(',');
};

/**
 * ## Usage
 *
 * ```javascript
 * import AmountFormatNew from '@Components/AmountFormatNew';
 *
 * export default class {
 *   render() {
 *     return (
 *       <AmountFormatNew
 *         amount={10.12}
 *         label="your label if you need"
 *         prefix="prefix text"
 *         inlineLabel
 *         prefixCurrency="UAH"
 *         identicalFractionFontSize // 12.12 kinda stuff, by default would be 12. small fraction 12
 *       />
 *     );
 *   }
 * }
 * ```
 */
var AmountFormatNew = (_dec = (0, _cnDecorator2.default)('amount-format-new'), _dec(_class = function (_React$PureComponent) {
  (0, _inherits3.default)(AmountFormatNew, _React$PureComponent);

  function AmountFormatNew() {
    (0, _classCallCheck3.default)(this, AmountFormatNew);
    return (0, _possibleConstructorReturn3.default)(this, (AmountFormatNew.__proto__ || (0, _getPrototypeOf2.default)(AmountFormatNew)).apply(this, arguments));
  }

  (0, _createClass3.default)(AmountFormatNew, [{
    key: 'render',
    value: function render(bem) {
      var _props = this.props,
          label = _props.label,
          amount = _props.amount,
          inlineLabel = _props.inlineLabel,
          prefix = _props.prefix,
          prefixCurrency = _props.prefixCurrency,
          suffix = _props.suffix,
          suffixCurrency = _props.suffixCurrency,
          identicalFractionFontSize = _props.identicalFractionFontSize,
          inherit = _props.inherit;

      var _decomposeAmount = decomposeAmount(amount),
          _decomposeAmount2 = (0, _slicedToArray3.default)(_decomposeAmount, 2),
          wholePart = _decomposeAmount2[0],
          fraction = _decomposeAmount2[1];

      var style = inherit ? {
        color: 'inherit',
        fontWeight: 'inherit',
        fontSize: 'inherit'
      } : undefined;

      return _react2.default.createElement(
        'div',
        { style: style, className: bem({ 'inline-label': inlineLabel }) },
        label && _react2.default.createElement(
          'p',
          { style: style, className: bem('label', { inline: inlineLabel }) },
          label
        ),
        _react2.default.createElement(
          'div',
          { style: style, className: bem('value-wrap') },
          _react2.default.createElement(
            'span',
            { style: style, className: bem('value') },
            prefix && _react2.default.createElement(
              'span',
              { style: style, className: bem('prefix') },
              prefix,
              ' '
            ),
            prefixCurrency && _react2.default.createElement(
              'span',
              { className: bem('currency') },
              _react2.default.createElement('img', {
                src: CURRENCIES[prefixCurrency],
                alt: prefixCurrency,
                className: bem('currency-img', { 'full-height': identicalFractionFontSize })
              })
            ),
            parseFloat(amount) >= 0 ? _react2.default.createElement(
              'span',
              { style: style, className: bem('amount') },
              prefixCurrency && ' ',
              _react2.default.createElement(
                'span',
                { className: bem('amount-whole-part') },
                wholePart
              ),
              '.',
              _react2.default.createElement(
                'span',
                {
                  style: style,
                  className: bem('amount-fraction', { 'identical-font-size': identicalFractionFontSize })
                },
                fraction
              ),
              suffixCurrency && ' '
            ) : _react2.default.createElement(
              'span',
              {
                style: style,
                className: bem('amount-empty')
              },
              prefixCurrency && ' ',
              '\u2014 \u2014 . \u2014 \u2014',
              suffixCurrency && ' '
            ),
            suffixCurrency && _react2.default.createElement(
              'span',
              { className: bem('currency') },
              _react2.default.createElement('img', {
                src: CURRENCIES[suffixCurrency],
                alt: suffixCurrency,
                className: bem('currency-img', { 'full-height': identicalFractionFontSize })
              })
            ),
            suffix && _react2.default.createElement(
              'span',
              { style: style, className: bem('suffix') },
              ' ',
              suffix
            )
          )
        )
      );
    }
  }]);
  return AmountFormatNew;
}(_react2.default.PureComponent)) || _class);
AmountFormatNew.displayName = 'AmountFormatNew';
AmountFormatNew.propTypes = {
  amount: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  label: _propTypes2.default.string,
  inlineLabel: _propTypes2.default.bool,
  prefix: _propTypes2.default.string,
  prefixCurrency: _propTypes2.default.oneOf(['UAH', 'USD', 'EUR', '']),
  suffix: _propTypes2.default.string,
  suffixCurrency: _propTypes2.default.oneOf(['UAH', 'USD', 'EUR', '']),
  identicalFractionFontSize: _propTypes2.default.bool,
  inherit: _propTypes2.default.bool
};
AmountFormatNew.defaultProps = {
  amount: '',
  label: '',
  inlineLabel: false,
  prefix: '',
  prefixCurrency: '',
  suffix: '',
  suffixCurrency: '',
  identicalFractionFontSize: false,
  inherit: false
};
exports.default = AmountFormatNew;