'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactNebo15CurrencyInput = require('react-nebo15-currency-input');

var _reactNebo15CurrencyInput2 = _interopRequireDefault(_reactNebo15CurrencyInput);

var _TextInput = require('../TextInput');

var _TextInput2 = _interopRequireDefault(_TextInput);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * ## Usage
 *
 * ```javascript
 * import { Field } from 'redux-form/immutable';
 * import AmountInput from '@Components/AmountInput';
 *
 * export default class {
 *   render() {
 *     return (
 *       <Field
 *          name="amount"
 *          component={AmountInput}
 *          label="Amount"
 *          precision={2}
 *       />
 *     );
 *   }
 * }
 * ```
 */
var AmountInput = function (_React$Component) {
  (0, _inherits3.default)(AmountInput, _React$Component);

  function AmountInput() {
    (0, _classCallCheck3.default)(this, AmountInput);
    return (0, _possibleConstructorReturn3.default)(this, (AmountInput.__proto__ || (0, _getPrototypeOf2.default)(AmountInput)).apply(this, arguments));
  }

  (0, _createClass3.default)(AmountInput, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          decimalSeparator = _props.decimalSeparator,
          precision = _props.precision,
          maxLength = _props.maxLength,
          defaultPrecision = _props.defaultPrecision;


      return _react2.default.createElement(_TextInput2.default, (0, _extends3.default)({}, this.props, {
        inputComponent: _reactNebo15CurrencyInput2.default,
        inputProps: {
          decimalSeparator: decimalSeparator,
          precision: precision,
          maxLength: maxLength,
          onBlur: function onBlur(e) {
            if (!defaultPrecision || e.target.value.length === 0) {
              return;
            }

            e.stopPropagation();

            var amount = e.target.value.split(decimalSeparator);

            if (amount.length === 1) {
              amount[1] = new Array(precision + 1).join('0');
            } else if (amount[1].length === 1) {
              amount[1] += new Array(precision).join('0');
            }

            e.target.value = '' + amount[0] + decimalSeparator + amount[1];

            _this2.props.input.onBlur(e);
          }
        }
      }));
    }
  }]);
  return AmountInput;
}(_react2.default.Component);

AmountInput.displayName = 'AmountInput';
AmountInput.propTypes = (0, _extends3.default)({}, _TextInput2.default.propTypes, {
  label: _propTypes2.default.string,
  disabled: _propTypes2.default.bool,
  prefix: _propTypes2.default.string,
  suffix: _propTypes2.default.string,
  input: _propTypes2.default.object,
  autoFocus: _propTypes2.default.bool,
  decimalSeparator: _propTypes2.default.string,
  precision: _propTypes2.default.number,
  maxLength: _propTypes2.default.number,
  defaultPrecision: _propTypes2.default.bool,
  theme: _propTypes2.default.oneOf(['default', 'payments-form', 'payments-form-amount'])
});
AmountInput.defaultProps = (0, _extends3.default)({}, _TextInput2.default.defaultProps, {
  decimalSeparator: '.',
  precision: 0,
  maxLength: 10,
  defaultPrecision: false
});
exports.default = AmountInput;