'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Progress = require('material-ui/Progress');

var _Button = require('material-ui/Button');

var _Button2 = _interopRequireDefault(_Button);

var _reactRouterDom = require('react-router-dom');

var _Icon = require('../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

require('./index.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * ## Usage
 *
 * ```javascript
 * import Button from '@Components/Button';
 *
 * export default class {
 *   render() {
 *     return (
 *       <div>
 *           <Button onClick={() => {}}>Example button</Button>
 *           <Button to="/account" theme="link">Example link</Button>
 *       </div>
 *     );
 *   }
 * }
 * ```
 */
var Button = function (_React$PureComponent) {
  (0, _inherits3.default)(Button, _React$PureComponent);

  function Button() {
    (0, _classCallCheck3.default)(this, Button);
    return (0, _possibleConstructorReturn3.default)(this, (Button.__proto__ || (0, _getPrototypeOf2.default)(Button)).apply(this, arguments));
  }

  (0, _createClass3.default)(Button, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          disabled = _props.disabled,
          onClick = _props.onClick,
          to = _props.to,
          theme = _props.theme,
          size = _props.size,
          block = _props.block,
          type = _props.type,
          color = _props.color,
          id = _props.id,
          loading = _props.loading,
          arrowSize = _props.arrowSize,
          isNew = _props.isNew,
          target = _props.target,
          href = _props.href,
          opacity = _props.opacity;


      var ROUND_BUTTONS_THEME = ['round', 'round-transparent'];

      return _react2.default.createElement(
        _Button2.default,
        {
          id: id,
          variant: ROUND_BUTTONS_THEME.includes(theme) ? 'fab' : 'flat',
          disabled: disabled || loading,
          classes: {
            root: (0, _classnames2.default)('button', 'button_theme_' + theme, 'button_color_' + color, 'button_size_' + size, block && 'button_block', opacity && 'button_with_opacity'),
            label: 'button__label',
            disabled: 'button_disabled'
          },
          onClick: onClick,
          to: to,
          target: href ? target : undefined,
          href: href || undefined,
          type: type,
          component: this.rootComponent,
          disableRipple: ['link', 'default-link', 'link-arrow'].includes(theme)
        },
        ROUND_BUTTONS_THEME.includes(theme) && loading && _react2.default.createElement(_Progress.CircularProgress, {
          classes: { root: 'button__loading' },
          size: 50,
          thickness: 2
        }),
        children,
        theme === 'link-arrow' && _react2.default.createElement(
          'span',
          { className: 'button__icon-arrow' },
          _react2.default.createElement(_Icon2.default, { name: 'arrow-down', size: arrowSize })
        ),
        isNew && _react2.default.createElement(
          'span',
          { className: 'button__icon-new' },
          'new'
        )
      );
    }
  }, {
    key: 'rootComponent',
    get: function get() {
      var _props2 = this.props,
          to = _props2.to,
          href = _props2.href;


      if (href) return 'a';
      if (to) return _reactRouterDom.Link;

      return 'button';
    }
  }]);
  return Button;
}(_react2.default.PureComponent);

Button.displayName = 'Button';
Button.propTypes = {
  /** Button content */
  children: _propTypes2.default.any.isRequired,
  /** Enable button disabled state, usefull when form is submitting */
  disabled: _propTypes2.default.bool,
  onClick: _propTypes2.default.func,
  to: _propTypes2.default.string,
  href: _propTypes2.default.string,
  target: _propTypes2.default.string,
  block: _propTypes2.default.bool,
  theme: _propTypes2.default.oneOf(['default', 'link', 'default-link', 'border', 'square', 'round', 'ellipse', 'flat-button', 'button-link', 'link-arrow', 'round-transparent']),
  size: _propTypes2.default.oneOf(['small', 'middle']),
  arrowSize: _propTypes2.default.number,
  type: _propTypes2.default.oneOf(['button', 'submit']),
  color: _propTypes2.default.oneOf(['default', 'white', 'green', 'red', 'transparent']),
  loading: _propTypes2.default.bool,
  id: _propTypes2.default.string,
  isNew: _propTypes2.default.bool,
  opacity: _propTypes2.default.bool
};
Button.defaultProps = {
  theme: 'default',
  size: 'middle',
  arrowSize: 14,
  type: 'button',
  color: 'default',
  target: '_blank',
  disabled: false,
  block: false,
  onClick: function onClick() {},
  to: undefined,
  href: undefined,
  loading: false,
  id: undefined,
  isNew: false,
  opacity: false
};
exports.default = Button;