'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Form = require('material-ui/Form');

var _Checkbox = require('material-ui/Checkbox');

var _Checkbox2 = _interopRequireDefault(_Checkbox);

require('./index.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * ## Usage
 *
 * ```javascript
 * import { Field } from 'redux-form/immutable';
 * import Checkbox from '@Components/Checkbox';
 *
 * export default class {
 *   render() {
 *     return (
 *       <Field
 *          name="myCheckbox"
 *          component={Checkbox}
 *          label="Label text"
 *       />
 *     );
 *   }
 * }
 * ```
 */
var Checkbox = function (_React$Component) {
  (0, _inherits3.default)(Checkbox, _React$Component);

  function Checkbox() {
    (0, _classCallCheck3.default)(this, Checkbox);
    return (0, _possibleConstructorReturn3.default)(this, (Checkbox.__proto__ || (0, _getPrototypeOf2.default)(Checkbox)).apply(this, arguments));
  }

  (0, _createClass3.default)(Checkbox, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          label = _props.label,
          helperText = _props.helperText,
          input = _props.input,
          id = _props.id,
          disabled = _props.disabled,
          meta = _props.meta;


      var error = (meta.touched || meta.visited && !meta.active || meta.submitFailed) && meta.error;

      return _react2.default.createElement(
        _Form.FormControl,
        { disabled: disabled, className: 'checkbox' },
        _react2.default.createElement(_Form.FormControlLabel, {
          control: _react2.default.createElement(_Checkbox2.default, (0, _extends3.default)({}, input, {
            classes: {
              checked: 'checkbox__input_checked'
            },
            id: id,
            icon: _react2.default.createElement('div', { className: 'checkbox__border' })
          })),
          label: _react2.default.createElement(
            'div',
            null,
            label
          )
        }),
        helperText && _react2.default.createElement(
          'div',
          { className: 'checkbox__help-text' },
          helperText
        ),
        error && _react2.default.createElement(
          _Form.FormHelperText,
          { className: 'checkbox__help-text_error' },
          error
        )
      );
    }
  }]);
  return Checkbox;
}(_react2.default.Component);

Checkbox.displayName = 'Checkbox';
Checkbox.propTypes = {
  label: _propTypes2.default.string,
  id: _propTypes2.default.string,
  disabled: _propTypes2.default.bool,
  helperText: _propTypes2.default.string,
  input: _propTypes2.default.object,
  meta: _propTypes2.default.object
};
Checkbox.defaultProps = {
  label: undefined,
  helperText: undefined,
  id: undefined,
  input: {},
  meta: {},
  disabled: false
};
exports.default = Checkbox;