'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Progress = require('material-ui/Progress');

require('./index.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var THICKNESSES = {
  thick: 2,
  normal: 3.5,
  bold: 5
};

var SIZES = {
  nano: 30,
  small: 50,
  medium: 100,
  large: 150
};

/**
 * ## Usage
 *
 * ```javascript
 * import CircularProgress from '@Components/CircularProgress';
 *
 * export default class {
 *   render() {
 *     return (
 *       <CircularProgress isPreload>
 *           <div>{'Hola!'}</div>
 *       </CircularProgress>
 *     );
 *   }
 * }
 * ```
 */

var CircularProgress = function (_React$PureComponent) {
  (0, _inherits3.default)(CircularProgress, _React$PureComponent);

  function CircularProgress() {
    (0, _classCallCheck3.default)(this, CircularProgress);
    return (0, _possibleConstructorReturn3.default)(this, (CircularProgress.__proto__ || (0, _getPrototypeOf2.default)(CircularProgress)).apply(this, arguments));
  }

  (0, _createClass3.default)(CircularProgress, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          isPreload = _props.isPreload,
          children = _props.children,
          thickness = _props.thickness,
          size = _props.size;


      if (isPreload) {
        return _react2.default.createElement(
          'section',
          { className: 'tas-circular-progress' },
          _react2.default.createElement(_Progress.CircularProgress, {
            thickness: THICKNESSES[thickness],
            size: SIZES[size]
          })
        );
      }

      return children;
    }
  }]);
  return CircularProgress;
}(_react2.default.PureComponent);

CircularProgress.displayName = 'CircularProgress';
CircularProgress.propTypes = {
  /** Will be display when isPreload - false */
  children: _propTypes2.default.any,
  isPreload: _propTypes2.default.bool,
  thickness: _propTypes2.default.oneOf(['thick', 'normal', 'bold']),
  size: _propTypes2.default.oneOf(['nano', 'small', 'medium', 'large'])
};
CircularProgress.defaultProps = {
  children: '',
  isPreload: false,
  thickness: 'normal',
  size: 'medium'
};
exports.default = CircularProgress;