'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactNebo15CurrencyInput = require('react-nebo15-currency-input');

var _reactNebo15CurrencyInput2 = _interopRequireDefault(_reactNebo15CurrencyInput);

var _reactNebo15Mask = require('react-nebo15-mask');

var _reactNebo15Mask2 = _interopRequireDefault(_reactNebo15Mask);

var _TextInput = require('../TextInput');

var _TextInput2 = _interopRequireDefault(_TextInput);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var CustomInput = function CustomInput(innerProps) {
  return function (props) {
    return _react2.default.createElement(_reactNebo15CurrencyInput2.default, (0, _extends3.default)({}, innerProps, props, { ref: function ref(_ref) {
        return _ref && props.inputRef(_ref.$input);
      } }));
  };
};

/**
 * ## Usage
 *
 * ```javascript
 * import { Field } from 'redux-form/immutable';
 * import CurrencyInput from '@Components/CurrencyInput';
 *
 * export default class {
 *   render() {
 *     return (
 *       <Field
 *          name="amount"
 *          component={CurrencyInput}
 *          label="Currency"
 *          precision={2}
 *       />
 *     );
 *   }
 * }
 * ```
 */

var CurrencyInput = function (_React$Component) {
  (0, _inherits3.default)(CurrencyInput, _React$Component);

  function CurrencyInput() {
    (0, _classCallCheck3.default)(this, CurrencyInput);
    return (0, _possibleConstructorReturn3.default)(this, (CurrencyInput.__proto__ || (0, _getPrototypeOf2.default)(CurrencyInput)).apply(this, arguments));
  }

  (0, _createClass3.default)(CurrencyInput, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          decimalSeparator = _props.decimalSeparator,
          precision = _props.precision;


      return _react2.default.createElement(_TextInput2.default, (0, _extends3.default)({}, this.props, {
        inputComponent: CustomInput({ decimalSeparator: decimalSeparator, precision: precision })
      }));
    }
  }]);
  return CurrencyInput;
}(_react2.default.Component);

CurrencyInput.displayName = 'CurrencyInput';
CurrencyInput.propTypes = (0, _extends3.default)({}, _TextInput2.default.propTypes, {
  label: _propTypes2.default.string,
  disabled: _propTypes2.default.bool,
  prefix: _propTypes2.default.string,
  suffix: _propTypes2.default.string,
  input: _propTypes2.default.object,
  autoFocus: _propTypes2.default.bool,
  decimalSeparator: _propTypes2.default.string,
  precision: _propTypes2.default.number,
  theme: _propTypes2.default.oneOf(['default', 'payments-form', 'payments-form-amount'])
});
CurrencyInput.defaultProps = (0, _extends3.default)({}, _TextInput2.default.defaultProps, {
  decimalSeparator: '.',
  precision: 0
});
exports.default = CurrencyInput;