'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _isEmpty = require('is-empty');

var _isEmpty2 = _interopRequireDefault(_isEmpty);

var _reactBootstrapDaterangepicker = require('react-bootstrap-daterangepicker');

var _reactBootstrapDaterangepicker2 = _interopRequireDefault(_reactBootstrapDaterangepicker);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

require('./index.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var CustomDatePicker = function (_Component) {
  (0, _inherits3.default)(CustomDatePicker, _Component);

  function CustomDatePicker() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, CustomDatePicker);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = CustomDatePicker.__proto__ || (0, _getPrototypeOf2.default)(CustomDatePicker)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      startDate: (0, _moment2.default)().startOf('isoweek'),
      endDate: (0, _moment2.default)(),
      dateSelected: false,
      datePicker: true,
      labelDate: ''
    }, _this.getYearItems = function (type, collection) {
      return collection.map(function (i) {
        return type + '_' + i;
      });
    }, _this.notifyParent = function (obj) {
      _this.props.handleApply(obj);
    }, _this.handleApply = function (event, picker) {
      var dateSelected = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
      var startDate = picker.startDate,
          endDate = picker.endDate;


      _this.setState({
        startDate: startDate,
        endDate: endDate,
        dateSelected: dateSelected,
        labelDate: _this.getLabel(startDate, endDate)
      });
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(CustomDatePicker, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var range = this.props.range;

      var format = 'DD-MM-YYYY';

      if (!(0, _isEmpty2.default)(range)) {
        this.setState({
          dateSelected: true,
          startDate: (0, _moment2.default)(range.startDate, format),
          endDate: (0, _moment2.default)(range.endDate, format)
        });
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(newProps) {
      if ((0, _isEmpty2.default)(newProps.range)) {
        this.setState({ dateSelected: false });
      }

      this.restartDatePicker();
    }
  }, {
    key: 'componentWillUpdate',
    value: function componentWillUpdate(nextProps, nextState) {
      if (this.state.startDate !== nextState.startDate || this.state.endDate !== nextState.endDate) {
        this.notifyParent(nextState);
      }
    }
  }, {
    key: 'getLabel',
    value: function getLabel(start, end) {
      var startDate = start || this.state.startDate;
      var endDate = end || this.state.endDate;
      var dateSelected = this.state.dateSelected;
      var _props = this.props,
          singleDatePicker = _props.singleDatePicker,
          customLabel = _props.customLabel;

      var format = 'DD.MM.YYYY';

      var label = '';

      if (!dateSelected) {
        label = customLabel;
      } else if (singleDatePicker) {
        label = startDate.format(format);
      } else if (startDate.format('MM') === endDate.format('MM')) {
        label = startDate.format('MMMM YYYY');
      } else {
        label = startDate.format(format) + ' - ' + endDate.format(format);
      }

      return label;
    }
  }, {
    key: 'restartDatePicker',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this.setState({ datePicker: false });

              case 2:
                _context.next = 4;
                return this.setState({ datePicker: true });

              case 4:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function restartDatePicker() {
        return _ref2.apply(this, arguments);
      }

      return restartDatePicker;
    }()
  }, {
    key: 'render',
    value: function render() {
      var _state = this.state,
          startDate = _state.startDate,
          endDate = _state.endDate,
          dateSelected = _state.dateSelected,
          datePicker = _state.datePicker;
      var _props2 = this.props,
          children = _props2.children,
          singleDatePicker = _props2.singleDatePicker,
          customLabel = _props2.customLabel;

      var format = 'DD.MM.YYYY';
      var label = '';

      if (customLabel) {
        label = this.getLabel();
      } else {
        label = dateSelected ? startDate.format(format) + ' - ' + endDate.format(format) : 'choose-range';
      }

      return _react2.default.createElement(
        'div',
        { className: 'date-picker-wrapper' },
        _react2.default.createElement(
          _reactBootstrapDaterangepicker2.default,
          {
            onApply: this.handleApply,
            locale: this.locale,
            ranges: this.ranges,
            maxDate: (0, _moment2.default)(),
            startDate: startDate,
            endDate: endDate,
            dateSelected: dateSelected,
            opens: 'left',
            parentEl: '.date-picker-wrapper',
            singleDatePicker: singleDatePicker
          },
          _react2.default.createElement(
            'span',
            { className: 'date-title-range' },
            children || label
          )
        )
      );
    }
  }, {
    key: 'ranges',
    get: function get() {
      var filter = this.props.filter;

      var result = {};
      var rangesList = {
        today: [(0, _moment2.default)(), (0, _moment2.default)()],
        yesterday: [(0, _moment2.default)().subtract(1, 'days'), (0, _moment2.default)().subtract(1, 'days')],
        thisWeek: [(0, _moment2.default)().startOf('isoweek'), (0, _moment2.default)()],
        prevWeek: [(0, _moment2.default)().startOf('isoweek').day(-6), (0, _moment2.default)().endOf('isoweek').day(-7)],
        month: [(0, _moment2.default)().startOf('month'), (0, _moment2.default)()],
        prevMonth: [(0, _moment2.default)().subtract(1, 'month').startOf('month'), (0, _moment2.default)().subtract(1, 'month').endOf('month')],
        quarter: [(0, _moment2.default)().startOf('quarter'), (0, _moment2.default)()],
        prevQuarter: [(0, _moment2.default)().startOf('quarter').quarter((0, _moment2.default)().quarter() - 1), (0, _moment2.default)().endOf('quarter').quarter((0, _moment2.default)().quarter() - 1)],
        year: [(0, _moment2.default)([(0, _moment2.default)().year(), 0, 1]), (0, _moment2.default)()]
      };

      for (var key in rangesList) {
        if (!Array.isArray(filter) || filter.includes(key)) {
          result[key] = rangesList[key];
        }
      }

      return result;
    }
  }, {
    key: 'locale',
    get: function get() {
      var t = this.props.t;

      return {
        customRangeLabel: 'choose-range',
        daysOfWeek: this.daysTitle,
        monthNames: this.monthsTitle,
        firstDay: 1,
        applyLabel: 'ok',
        cancelLabel: 'cancel'
      };
    }
  }, {
    key: 'monthsTitle',
    get: function get() {
      return this.getYearItems('month', [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12]);
    }
  }, {
    key: 'daysTitle',
    get: function get() {
      return this.getYearItems('day', [1, 2, 3, 4, 5, 6, 7]);
    }
  }]);
  return CustomDatePicker;
}(_react.Component);

CustomDatePicker.propTypes = {
  children: _propTypes2.default.node
};
CustomDatePicker.defaultProps = {
  children: null
};
exports.default = CustomDatePicker;