'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _cnDecorator = require('cn-decorator');

var _cnDecorator2 = _interopRequireDefault(_cnDecorator);

var _Input = require('material-ui/Input');

var _Input2 = _interopRequireDefault(_Input);

var _Menu = require('material-ui/Menu');

var _Form = require('material-ui/Form');

var _Select = require('material-ui/Select');

var _Select2 = _interopRequireDefault(_Select);

var _Progress = require('material-ui/Progress');

require('./index.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * ## Usage
 *
 * ```javascript
 * import Example from '@Components/CustomSelect';
 *
 * export default class {
 *   render() {
 *     return (
 *       <CustomSelect />
 *     );
 *   }
 * }
 * ```
 */
var CustomSelect = (_dec = (0, _cnDecorator2.default)('custom-select'), _dec(_class = function (_React$PureComponent) {
  (0, _inherits3.default)(CustomSelect, _React$PureComponent);

  function CustomSelect() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, CustomSelect);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = CustomSelect.__proto__ || (0, _getPrototypeOf2.default)(CustomSelect)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      editableMode: !_this.props.list.includes(_this.props.input.value)
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(CustomSelect, [{
    key: 'render',
    value: function render(bem) {
      var _this2 = this;

      var _props = this.props,
          input = _props.input,
          innerProps = _props.innerProps,
          meta = _props.meta,
          list = _props.list,
          id = _props.id,
          disabled = _props.disabled,
          loading = _props.loading,
          customLabel = _props.customLabel,
          change = _props.change;
      var editableMode = this.state.editableMode;


      var error = (meta.touched || meta.visited && !meta.active || meta.submitFailed) && meta.error;

      return _react2.default.createElement(
        _Form.FormControl,
        {
          disabled: disabled || loading,
          error: error,
          className: bem({ theme: this.props.theme, loading: loading, 'editable-mode': editableMode })
        },
        customLabel && _react2.default.createElement(
          'section',
          { className: bem('editable-input') },
          _react2.default.createElement(_Input2.default, (0, _extends3.default)({
            error: error || undefined,
            disabled: disabled,
            classes: {
              root: bem('input'),
              focused: bem('input', { focused: true }),
              error: bem('input', { error: true })
            },
            inputProps: (0, _extends3.default)({}, input, {
              name: input.name
            })
          }, innerProps, input))
        ),
        _react2.default.createElement(
          _Select2.default,
          (0, _extends3.default)({}, innerProps, input, {
            input: _react2.default.createElement(_Input2.default, {
              classes: {
                root: bem('input'),
                focused: bem('input', { focused: true }),
                error: bem('input', { error: true })
              },
              name: input.name,
              id: id
            }),
            onChange: function onChange(event) {
              var value = event.target.value;


              if (value === customLabel && editableMode) {
                return;
              }

              _this2.setState({ editableMode: value === customLabel });

              input.onChange(event);

              if (value === customLabel) {
                change(input.name, '');
              }
            }
          }),
          list.map(function (item) {
            return _react2.default.createElement(
              _Menu.MenuItem,
              { key: item, value: item },
              item
            );
          }),
          customLabel && _react2.default.createElement(
            _Menu.MenuItem,
            {
              className: bem('editable'),
              key: customLabel,
              value: customLabel
            },
            customLabel
          )
        ),
        error && _react2.default.createElement(
          _Form.FormHelperText,
          { className: bem('help-text', { error: true }) },
          error
        ),
        loading && _react2.default.createElement(_Progress.LinearProgress, { classes: { root: bem('progress') }, variant: 'query' })
      );
    }
  }]);
  return CustomSelect;
}(_react2.default.PureComponent)) || _class);
CustomSelect.displayName = 'CustomSelect';
CustomSelect.propTypes = {
  disabled: _propTypes2.default.bool,
  input: _propTypes2.default.object,
  innerProps: _propTypes2.default.object,
  meta: _propTypes2.default.object,
  id: _propTypes2.default.string,
  list: _propTypes2.default.array,
  customLabel: _propTypes2.default.string,
  theme: _propTypes2.default.oneOf(['default', 'payments-form', 'autofill-form']),
  loading: _propTypes2.default.bool
};
CustomSelect.defaultProps = {
  id: undefined,
  disabled: false,
  input: {
    value: '',
    name: ''
  },
  meta: {},
  innerProps: {},
  list: [],
  customLabel: '',
  theme: 'default',
  loading: false
};
exports.default = CustomSelect;