'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _materialUiPickers = require('material-ui-pickers');

var _Input = require('material-ui/Input');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

require('./index.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ARROW_BTN_SIZE = 24;
var ARROW_BTN_WIDTH = 8;
var ARROW_BTN_COLOR = '#000';
var ARROW_BTN_STYLE = {
  boxSizing: 'border-box',
  padding: 5
};
var LEFT_ARROW_POINTS = '45.63,75.8 0.375,38.087 45.63,0.375';
var RIGHT_ARROW_POINTS = '0.375,0.375 45.63,38.087 0.375,75.8';
var ArrowButton = function ArrowButton(_ref) {
  var points = _ref.points;
  return _react2.default.createElement(
    'svg',
    {
      width: ARROW_BTN_SIZE,
      height: ARROW_BTN_SIZE,
      style: ARROW_BTN_STYLE,
      viewBox: '0 0 50 80',
      xmlSpace: 'preserve'
    },
    _react2.default.createElement('polyline', {
      fill: 'none',
      stroke: ARROW_BTN_COLOR,
      strokeWidth: ARROW_BTN_WIDTH,
      strokeLinecap: 'round',
      strokeLinejoin: 'round',
      points: points
    })
  );
};
/**
 * ## Usage
 *
 * ```javascript
 * import Button from '@Components/DatePicker';
 *
 * link on source library https://github.com/dmtrKovalenko/material-ui-pickers
 *
 * export default class {
 *   render() {
 *     return (
 *       <div>
 *           <DatePicker input={{
 *            onChange(date){}
 *           }}>
 *              Example button
 *           </Button>
 *       </div>
 *     );
 *   }
 * }
 * ```
 */

var CustomDatePicker = function (_React$PureComponent) {
  (0, _inherits3.default)(CustomDatePicker, _React$PureComponent);

  function CustomDatePicker() {
    var _ref2;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, CustomDatePicker);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref2 = CustomDatePicker.__proto__ || (0, _getPrototypeOf2.default)(CustomDatePicker)).call.apply(_ref2, [this].concat(args))), _this), _this.handleDateChange = function (date) {
      _this.props.input.onChange(date);
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(CustomDatePicker, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          input = _props.input,
          innerProps = _props.innerProps,
          format = _props.format,
          autoOk = _props.autoOk,
          label = _props.label,
          okLabel = _props.okLabel,
          cancelLabel = _props.cancelLabel,
          clearLabel = _props.clearLabel,
          disabled = _props.disabled,
          meta = _props.meta,
          fullwidth = _props.fullwidth,
          openToYearSelection = _props.openToYearSelection,
          disablePast = _props.disablePast,
          disableFuture = _props.disableFuture,
          minDate = _props.minDate,
          maxDate = _props.maxDate;
      var value = input.value;

      var error = (meta.touched || meta.visited && !meta.active) && meta.error;

      return _react2.default.createElement(
        'div',
        { className: 'tas-date-picker' },
        _react2.default.createElement(
          _Input.InputLabel,
          {
            className: (0, _classnames2.default)('tas-date-picker__label', { 'tas-date-picker__label_focused': value }),
            error: error
          },
          label
        ),
        _react2.default.createElement(_materialUiPickers.DatePicker, (0, _extends3.default)({
          className: (0, _classnames2.default)('tas-date-picker__DP', {
            'tas-date-picker__DP_fullwidth': fullwidth
          }),
          disabled: disabled,
          error: error,
          okLabel: okLabel,
          cancelLabel: cancelLabel,
          clearLabel: clearLabel,
          format: format,
          autoOk: autoOk,
          openToYearSelection: openToYearSelection,
          disablePast: disablePast,
          disableFuture: disableFuture,
          minDate: minDate,
          maxDate: maxDate,
          animateYearScrolling: true,
          clearable: true,
          leftArrowIcon: _react2.default.createElement(ArrowButton, { points: LEFT_ARROW_POINTS }),
          rightArrowIcon: _react2.default.createElement(ArrowButton, { points: RIGHT_ARROW_POINTS })
        }, input, innerProps, {
          onChange: this.handleDateChange
        }))
      );
    }
  }]);
  return CustomDatePicker;
}(_react2.default.PureComponent);

CustomDatePicker.displayName = 'DatePicker';
CustomDatePicker.propTypes = {
  okLabel: _propTypes2.default.string,
  cancelLabel: _propTypes2.default.string,
  clearLabel: _propTypes2.default.string,
  label: _propTypes2.default.string,
  openToYearSelection: _propTypes2.default.bool,
  autoOk: _propTypes2.default.bool,
  disablePast: _propTypes2.default.bool,
  disableFuture: _propTypes2.default.bool,
  disabled: _propTypes2.default.bool,
  fullwidth: _propTypes2.default.bool,
  minDate: _propTypes2.default.string,
  maxDate: _propTypes2.default.string,
  format: _propTypes2.default.oneOf(['MMMM Do', 'MMMM DD', 'MMMM.DD', 'MM Do YY', 'MM.Do.YY', 'MM.DD.YY', 'MM.DD.YYYY']),
  input: _propTypes2.default.shape({
    onChange: _propTypes2.default.func.isRequired,
    value: _propTypes2.default.string
  }).isRequired,
  meta: _propTypes2.default.shape({
    touched: _propTypes2.default.bool,
    visited: _propTypes2.default.bool,
    active: _propTypes2.default.bool,
    error: _propTypes2.default.string
  })
};
CustomDatePicker.defaultProps = {
  label: '',
  okLabel: undefined,
  cancelLabel: undefined,
  clearLabel: undefined,
  format: 'MM.DD.YY',
  autoOk: true,
  disablePast: false,
  disabled: false,
  disableFuture: false,
  openToYearSelection: false,
  fullwidth: false,
  minDate: '1950-01-01',
  maxDate: '2050-01-01',
  input: {
    value: null,
    onChange: function onChange() {}
  },
  meta: {
    touched: false,
    visited: false,
    active: false,
    error: ''
  }
};
exports.default = CustomDatePicker;