'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DateRangePicker = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _materialUi = require('material-ui');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _materialUiPickers = require('material-ui-pickers');

var _Input = require('material-ui/Input');

var _Form = require('material-ui/Form');

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _Icon = require('../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

require('./index.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DateRangePicker = function (_Component) {
  (0, _inherits3.default)(DateRangePicker, _Component);

  function DateRangePicker() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, DateRangePicker);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = DateRangePicker.__proto__ || (0, _getPrototypeOf2.default)(DateRangePicker)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      startDate: null,
      endDate: null
    }, _this.handleChange = function () {
      _this.props.input.onChange({ start: _this.state.startDate.format('x'), end: _this.state.endDate.format('x') });
    }, _this.handleDateChange = function (currentDate) {
      var _this$state = _this.state,
          startDate = _this$state.startDate,
          endDate = _this$state.endDate;


      if (!startDate) {
        _this.setState({ startDate: currentDate });
      } else if (startDate.isSame(currentDate)) {
        _this.setState({ startDate: endDate || null, endDate: null });
      } else if (startDate.isAfter(currentDate)) {
        _this.setState({ startDate: currentDate, endDate: startDate });
      } else if (endDate && endDate.isSame(currentDate)) {
        _this.setState({ endDate: null });
      } else {
        _this.setState({ endDate: currentDate });
      }
      // this.setState({ selectedDate: currentDate });
    }, _this.formatWeekSelectLabel = function () {
      var _this$value = _this.value,
          start = _this$value.start,
          end = _this$value.end;

      if (!start || !end) {
        return '';
      }
      var startDate = (0, _moment2.default)(Number(start));
      var endDate = (0, _moment2.default)(Number(end));

      if (startDate && endDate && startDate.isValid() && endDate.isValid()) {
        return startDate.format('DD.MM.YY') + ' - ' + endDate.format('DD.MM.YY');
      }
      return '';
    }, _this.handleClose = function () {
      _this.setState({
        startDate: null,
        endDate: null
      });
    }, _this.renderWrappedDefaultDay = function (date, selectedDate, dayInCurrentMonth) {
      var _this$state2 = _this.state,
          startDate = _this$state2.startDate,
          endDate = _this$state2.endDate;


      var dayIsBetween = date.isSame(startDate) || date.isSame(endDate) || date.isAfter(startDate) && date.isBefore(endDate);

      var firstDay = date.isSame(startDate, 'day');
      var lastDay = date.isSame(endDate, 'day');

      var wrapperClassName = (0, _classnames2.default)({
        'dp-day__hl': dayIsBetween,
        'dp-day__hl_f': firstDay,
        'dp-day__hl_l': lastDay
      });

      var dayClassName = (0, _classnames2.default)('dp-day', {
        'dp-day__other-month ': !dayInCurrentMonth,
        'dp-day__hl-other-month': !dayInCurrentMonth && dayIsBetween
      });

      return _react2.default.createElement(
        'div',
        { className: wrapperClassName },
        _react2.default.createElement(
          _materialUi.IconButton,
          { className: dayClassName, onClick: function onClick() {
              return _this.handleDateChange(date);
            } },
          _react2.default.createElement(
            'span',
            null,
            ' ',
            date.format('DD'),
            ' '
          )
        )
      );
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(DateRangePicker, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          label = _props.label,
          input = _props.input,
          innerProps = _props.innerProps,
          meta = _props.meta,
          helperText = _props.helperText,
          theme = _props.theme;
      var value = input.value;

      var error = (meta.touched || meta.visited && !meta.active) && meta.error;

      var BLOCK_NAME = 'tas-date-picker';
      return _react2.default.createElement(
        _Form.FormControl,
        { className: 'tas-date-picker tas-date-picker_theme_' + theme },
        _react2.default.createElement(
          _Input.InputLabel,
          {
            className: (0, _classnames2.default)('tas-date-picker__label', { 'tas-date-picker__label_focused': value }),
            error: error
          },
          label
        ),
        _react2.default.createElement(_materialUiPickers.DatePicker, (0, _extends3.default)({}, input, innerProps, meta, {
          onChange: this.handleChange,
          renderDay: this.renderWrappedDefaultDay,
          labelFunc: this.formatWeekSelectLabel,
          onClose: this.handleClose,
          leftArrowIcon: _react2.default.createElement(_Icon2.default, { name: 'arrow-down', rotate: '90deg' }),
          rightArrowIcon: _react2.default.createElement(_Icon2.default, { name: 'arrow-down', rotate: '-90deg' }),
          animateYearScrolling: true,
          inputProps: {
            classes: {
              root: BLOCK_NAME + '__input',
              focused: BLOCK_NAME + '__input_focused',
              error: BLOCK_NAME + '__input_error'
            }
          },
          className: BLOCK_NAME + '__input'
        })),
        helperText && _react2.default.createElement(
          _Form.FormHelperText,
          { className: BLOCK_NAME + '__help-text' },
          helperText
        ),
        error && _react2.default.createElement(
          _Form.FormHelperText,
          { className: BLOCK_NAME + '__help-text ' + BLOCK_NAME + '__help-text_error' },
          error
        )
      );
    }
  }, {
    key: 'value',
    get: function get() {
      if (this.props.input && this.props.input.value) {
        return this.props.input.value;
      }
      return {
        start: null,
        end: null
      };
    }
  }]);
  return DateRangePicker;
}(_react.Component);

DateRangePicker.displayName = 'DateRangePicker';
DateRangePicker.propTypes = {
  theme: _propTypes2.default.oneOf(['default', 'label']),
  classes: _propTypes2.default.object,
  okLabel: _propTypes2.default.string,
  cancelLabel: _propTypes2.default.string,
  clearLabel: _propTypes2.default.string,
  label: _propTypes2.default.string,
  disabled: _propTypes2.default.bool,
  fullwidth: _propTypes2.default.bool,
  input: _propTypes2.default.shape({
    onChange: _propTypes2.default.func.isRequired,
    value: _propTypes2.default.object
  }).isRequired,
  meta: _propTypes2.default.shape({
    touched: _propTypes2.default.bool,
    visited: _propTypes2.default.bool,
    active: _propTypes2.default.bool,
    error: _propTypes2.default.string
  })
};
DateRangePicker.defaultProps = {
  theme: 'default',
  classes: {},
  label: '',
  okLabel: undefined,
  cancelLabel: undefined,
  clearLabel: undefined,
  disabled: false,
  fullwidth: false,
  input: { // eslint-disable-line
    value: null,
    onChange: function onChange() {}
  },
  meta: {
    touched: false,
    visited: false,
    active: false,
    error: ''
  }
};
exports.DateRangePicker = DateRangePicker;
exports.default = DateRangePicker;