'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Input = require('material-ui/Input');

var _Input2 = _interopRequireDefault(_Input);

var _Menu = require('material-ui/Menu');

var _Select = require('material-ui/Select');

var _Select2 = _interopRequireDefault(_Select);

require('./index.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * ## Usage
 *
 * ```javascript
 * import Example from '@Components/Select';
 *
 * export default class {
     * state = {
        value: 1,
      };

      handleChange(value) {
        this.setState({ value });
      };

 *   render() {
 *     return (
 *       <DropDown
          value={this.state.value}
          onChange={value => { handleChange(value); }}
          list={[
            { label: 'One', value: 1 },
            { label: 'Two', value: 2 },
            { label: 'Three', value: 3 },
          ]}
          theme="your-custom-theme"
        />
 *     );
 *   }
 * }
 * ```
 */
var DropDown = function (_React$PureComponent) {
  (0, _inherits3.default)(DropDown, _React$PureComponent);

  function DropDown() {
    (0, _classCallCheck3.default)(this, DropDown);
    return (0, _possibleConstructorReturn3.default)(this, (DropDown.__proto__ || (0, _getPrototypeOf2.default)(DropDown)).apply(this, arguments));
  }

  (0, _createClass3.default)(DropDown, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          list = _props.list,
          id = _props.id,
          emptyText = _props.emptyText,
          disabled = _props.disabled,
          value = _props.value,
          withIcon = _props.withIcon,
          theme = _props.theme,
          _onChange = _props.onChange;

      return _react2.default.createElement(
        _Select2.default,
        {
          value: value,
          disabled: disabled,
          onChange: function onChange(e) {
            _onChange(e.target.value);
          },
          className: 'drop-down drop-down_theme_' + theme,
          classes: {
            icon: 'drop-down__icon ' + (withIcon ? 'drop-down__icon_show' : '')
          },
          MenuProps: {
            classes: { paper: 'dropDownModal-menu dropDownModal-menu_theme_' + theme },
            MenuListProps: { className: 'dropDownModal-menu__list-root' }
          },
          input: _react2.default.createElement(_Input2.default, {
            classes: {
              input: 'drop-down__input ' + (withIcon ? 'drop-down__input_showIcon' : ''),
              focused: 'drop-down_focused',
              disabled: 'drop-down_disabled'
            },
            id: id
          })
        },
        emptyText && _react2.default.createElement(
          _Menu.MenuItem,
          { className: 'dropDownModal-menu__list-root__emptyText', value: '' },
          _react2.default.createElement(
            'em',
            null,
            emptyText
          )
        ),
        list.map(function (_ref) {
          var value = _ref.value,
              label = _ref.label;
          return _react2.default.createElement(
            _Menu.MenuItem,
            {
              key: value,
              value: value,
              classes: { selected: 'dropDownModal-menu__list-root_selected' }
            },
            label
          );
        })
      );
    }
  }]);
  return DropDown;
}(_react2.default.PureComponent);

DropDown.displayName = 'DropDown';
DropDown.propTypes = {
  disabled: _propTypes2.default.bool,
  withIcon: _propTypes2.default.bool,
  value: _propTypes2.default.any,
  id: _propTypes2.default.string,
  theme: _propTypes2.default.string,
  list: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    value: _propTypes2.default.any,
    label: _propTypes2.default.string
  })),
  emptyText: _propTypes2.default.any,
  onChange: _propTypes2.default.func
};
DropDown.defaultProps = {
  id: undefined,
  value: null,
  theme: 'default',
  emptyText: undefined,
  disabled: false,
  withIcon: false,
  onChange: function onChange() {},
  list: []
};
exports.default = DropDown;