'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends3 = require('babel-runtime/helpers/extends');

var _extends4 = _interopRequireDefault(_extends3);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _cnDecorator = require('cn-decorator');

var _cnDecorator2 = _interopRequireDefault(_cnDecorator);

require('./index.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * ## Usage
 *
 * ```javascript
 * import { Field } from 'redux-form/immutable';
 * import TextInput from '@Components/TextInput';
 *
 * export default class {
 *   render() {
 *     return (
 *       <Field
 *          name="myInput"
 *          component={TextInput}
 *          label="Label text"
 *       />
 *     );
 *   }
 * }
 * ```
 */
var EditableInput = (_dec = (0, _cnDecorator2.default)('editable-input'), _dec(_class = function (_React$Component) {
  (0, _inherits3.default)(EditableInput, _React$Component);

  function EditableInput() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, EditableInput);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = EditableInput.__proto__ || (0, _getPrototypeOf2.default)(EditableInput)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      query: '',
      match: {}
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(EditableInput, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _props = this.props,
          pattern = _props.pattern,
          patternComponents = _props.patternComponents,
          _props$autofillValues = _props.autofillValues,
          autofillValues = _props$autofillValues === undefined ? {} : _props$autofillValues,
          handleApply = _props.handleApply;

      var match = {};

      pattern.forEach(function (item) {
        if (autofillValues[item]) {
          match[item] = autofillValues[item];
        }
      });

      var query = pattern.map(function (word) {
        return match[word] ? match[word] : word;
      });

      this.setState({ match: match });

      handleApply(query);
    }
  }, {
    key: 'handleChange',
    value: function handleChange(_ref2) {
      var name = _ref2.name,
          value = _ref2.value;
      var _props2 = this.props,
          pattern = _props2.pattern,
          handleApply = _props2.handleApply;
      var match = this.state.match;

      var updatedMatch = (0, _extends4.default)({}, match, (0, _defineProperty3.default)({}, name, value));

      var query = pattern.map(function (word) {
        return updatedMatch[word] ? updatedMatch[word] : word;
      });

      this.setState({
        match: updatedMatch,
        query: query
      });

      handleApply(query);
    }
  }, {
    key: 'render',
    value: function render(bem) {
      var _this2 = this;

      var _props3 = this.props,
          pattern = _props3.pattern,
          patternComponents = _props3.patternComponents,
          autofillValues = _props3.autofillValues;


      return _react2.default.createElement(
        'section',
        { className: bem({ theme: this.props.theme }) },
        pattern.map(function (item) {
          return patternComponents[item] && patternComponents[item].component ? patternComponents[item].component((0, _extends4.default)({}, _this2.props, {
            defaultValue: autofillValues[item],
            handleChange: _this2.handleChange.bind(_this2)
          })) : [_react2.default.createElement(
            'span',
            { className: bem('text') },
            item
          ), _react2.default.createElement('span', { className: bem('space') })];
        })
      );
    }
  }]);
  return EditableInput;
}(_react2.default.Component)) || _class);
EditableInput.displayName = 'EditableInput';
EditableInput.propTypes = {
  theme: _propTypes2.default.oneOf(['default', 'payments-form', 'payments-form-numbers', 'autofill-form'])
};
EditableInput.defaultProps = {
  theme: 'default'
};
exports.default = EditableInput;