'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Button = require('material-ui/Button');

var _Button2 = _interopRequireDefault(_Button);

var _ic_add_white = require('./images/ic_add_white.svg');

var _ic_add_white2 = _interopRequireDefault(_ic_add_white);

var _ic_export = require('./images/ic_export.svg');

var _ic_export2 = _interopRequireDefault(_ic_export);

var _ic_import = require('./images/ic_import.svg');

var _ic_import2 = _interopRequireDefault(_ic_import);

var _ic_print = require('./images/ic_print.svg');

var _ic_print2 = _interopRequireDefault(_ic_print);

var _ic_eye_outline = require('./images/ic_eye_outline.svg');

var _ic_eye_outline2 = _interopRequireDefault(_ic_eye_outline);

var _ic_eye_outline_off = require('./images/ic_eye_outline_off.svg');

var _ic_eye_outline_off2 = _interopRequireDefault(_ic_eye_outline_off);

var _ic_favorite = require('./images/ic_favorite.svg');

var _ic_favorite2 = _interopRequireDefault(_ic_favorite);

require('./index.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var IMAGES = {
  add: _ic_add_white2.default,
  export: _ic_export2.default,
  import: _ic_import2.default,
  print: _ic_print2.default,
  eye_outline: _ic_eye_outline2.default,
  eye_outline_off: _ic_eye_outline_off2.default,
  favorite: _ic_favorite2.default
};

/**
 * ## Usage
 *
 * ```javascript
 *
 * DEPRECATED. Use <Button theme="round" />
 *
 * import Button from '@Components/Button';
 *
 * export default class {
 *   render() {
 *     return (
 *       <FabButton
 *          className="your-custom-class"
 *          disabled={false}
 *          theme="your-custom-theme"
 *       />
 *     );
 *   }
 * }
 * ```
 */

var FabButton = function (_React$PureComponent) {
  (0, _inherits3.default)(FabButton, _React$PureComponent);

  function FabButton() {
    (0, _classCallCheck3.default)(this, FabButton);
    return (0, _possibleConstructorReturn3.default)(this, (FabButton.__proto__ || (0, _getPrototypeOf2.default)(FabButton)).apply(this, arguments));
  }

  (0, _createClass3.default)(FabButton, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          disabled = _props.disabled,
          onClick = _props.onClick,
          className = _props.className,
          theme = _props.theme,
          type = _props.type,
          iconType = _props.iconType,
          bgColor = _props.bgColor,
          disableRipple = _props.disableRipple;


      return _react2.default.createElement(
        _Button2.default,
        {
          variant: 'fab',
          classes: {
            root: className + ' button-fab button-fab_theme-' + theme + ' button-fab_bgColor-' + bgColor,
            disabled: 'button-fab_disabled-' + bgColor
          },
          type: type,
          disableRipple: disableRipple,
          disabled: disabled,
          onClick: onClick
        },
        children || _react2.default.createElement('img', { className: 'button-fab__default-img', src: IMAGES[iconType], alt: iconType })
      );
    }
  }]);
  return FabButton;
}(_react2.default.PureComponent);

FabButton.displayName = 'FabButton';
FabButton.propTypes = {
  children: _propTypes2.default.oneOfType([_propTypes2.default.node, null]),
  disabled: _propTypes2.default.bool,
  disableRipple: _propTypes2.default.bool,
  onClick: _propTypes2.default.func,
  bgColor: _propTypes2.default.oneOf(['white', 'primary']),
  iconType: _propTypes2.default.oneOf(['add', 'export', 'import', 'print', 'eye_outline', 'eye_outline_off', 'favorite']),
  theme: _propTypes2.default.string,
  className: _propTypes2.default.string,
  type: _propTypes2.default.oneOf(['button', 'submit'])
};
FabButton.defaultProps = {
  theme: 'default',
  type: 'button',
  bgColor: 'white',
  className: '',
  disabled: false,
  disableRipple: true,
  iconType: 'print',
  children: null,
  onClick: function onClick() {}
};
exports.default = FabButton;