'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ICONS = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _icons = require('./icons.font');

var _icons2 = _interopRequireDefault(_icons);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ICONS = exports.ICONS = ['add', 'accounts', 'acquiring', 'arrow-down', 'attach-file', 'briefcase', 'calendar', 'check-double', 'check-round', 'close', 'confirm-email', 'confirm-phone', 'content-copy', 'deposits', 'dev-tools', 'done', 'download', 'dustbin', 'divide', 'edit', 'error', 'export', 'export-file', 'eye', 'eye-close', 'face-sad', 'facebook', 'favorite', 'marketplace', 'menu', 'payments', 'print', 'heart', 'repeat', 'return', 'search', 'sign', 'sign-add', 'sign-crossed', 'sign-delete', 'view-headline', 'view-module', 'warning', 'star', 'trash', 'money-back', 'credit-card', 'invoice', 'mobile-phone', 'online-payment', 'price-tag', 'big-five', 'identification', 'my-card', 'check', 'documents', 'exit', 'uah', 'upload', 'eur', 'usd', 'mail-unread', 'mail'];

/**
 * ## Usage
 *
 * ```javascript
 * import Icon from '@components/Icon';
 *
 * export default class {
 *   render() {
 *     return (
 *       <Icon name="my-icon" />
 *     );
 *   }
 * }
 * ```
 */
var Icon = function Icon(_ref) {
  var name = _ref.name,
      size = _ref.size,
      color = _ref.color,
      fill = _ref.fill,
      round = _ref.round,
      rotate = _ref.rotate;
  return _react2.default.createElement('i', {
    style: {
      color: color,
      fontSize: size,
      backgroundColor: fill,
      transform: 'rotate(' + rotate + 'deg)'
    },
    className: (0, _classnames2.default)(_icons2.default.icon, _icons2.default['icon__' + name], round && _icons2.default.icon_round)
  });
};

Icon.displayName = 'Icon';

Icon.propTypes = {
  /**
   * Icon name
   */
  name: _propTypes2.default.oneOf(ICONS).isRequired,

  /**
   * Icon size
   */
  size: _propTypes2.default.number,

  /**
   * Icon color
   */
  color: _propTypes2.default.string,

  /**
   * Icon background
   */
  fill: _propTypes2.default.string,

  /**
   * Set border-radius: 50%
   */
  round: _propTypes2.default.bool,

  /**
   * Icon rotate
   */
  rotate: _propTypes2.default.string

};

Icon.defaultProps = {
  size: 20,
  color: 'inherit',
  fill: 'transparent',
  round: false,
  rotate: '0'
};

exports.default = Icon;