'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _cnDecorator = require('cn-decorator');

var _cnDecorator2 = _interopRequireDefault(_cnDecorator);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

var _Title = require('../Title');

var _Title2 = _interopRequireDefault(_Title);

var _index = require('./index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * ## Usage
 *
 * ```javascript
 * import Alert from '@Components/Modal/Alert';
 *
 * export default class {
 *   render() {
 *      return (
 *        <Alert
 *          title="Title text..."
 *          text="Some content..."
 *          confirmLabel="Agree"
 *          onConfirm={...}
 *        />
 *      );
 *   }
 * }
 * ```
 */
var AlertModal = (_dec = (0, _cnDecorator2.default)('tas-modal'), _dec(_class = function (_React$Component) {
  (0, _inherits3.default)(AlertModal, _React$Component);

  function AlertModal() {
    (0, _classCallCheck3.default)(this, AlertModal);
    return (0, _possibleConstructorReturn3.default)(this, (AlertModal.__proto__ || (0, _getPrototypeOf2.default)(AlertModal)).apply(this, arguments));
  }

  (0, _createClass3.default)(AlertModal, [{
    key: 'render',
    value: function render(bem) {
      var _this2 = this;

      var _props = this.props,
          onConfirm = _props.onConfirm,
          title = _props.title,
          text = _props.text,
          confirmLabel = _props.confirmLabel,
          name = _props.name;


      return _react2.default.createElement(
        _index2.default,
        {
          name: name,
          ref: function ref(_ref) {
            _this2.$modal = _ref && _ref.getWrappedInstance();
          },
          header: _react2.default.createElement(
            _Title2.default,
            { heading: 4, theme: 'custom' },
            title
          ),
          footer: _react2.default.createElement(
            'div',
            { className: bem('alert-footer') },
            _react2.default.createElement(
              _Button2.default,
              {
                theme: 'button-link',
                onClick: function onClick(e) {
                  _this2.$modal.hide();
                  onConfirm(e);
                }
              },
              confirmLabel
            )
          ),
          onClose: onConfirm
        },
        _react2.default.createElement(
          'span',
          { className: bem('alert-text') },
          text
        )
      );
    }
  }]);
  return AlertModal;
}(_react2.default.Component)) || _class);
AlertModal.displayName = 'AlertModal';
AlertModal.propTypes = {
  name: _propTypes2.default.string.isRequired,
  title: _propTypes2.default.string,
  text: _propTypes2.default.string,
  confirmLabel: _propTypes2.default.string,
  onConfirm: _propTypes2.default.func
};
AlertModal.defaultProps = {
  title: 'Alert',
  text: '',
  confirmLabel: 'Confirm',
  onConfirm: function onConfirm() {}
};
exports.default = AlertModal;