'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _cnDecorator = require('cn-decorator');

var _cnDecorator2 = _interopRequireDefault(_cnDecorator);

var _index = require('./index');

var _index2 = _interopRequireDefault(_index);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

var _Title = require('../Title');

var _Title2 = _interopRequireDefault(_Title);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * ## Usage
 *
 * ```javascript
 * import Confirm from '@Components/Modal/Confirm';
 *
 * export default class {
 *   render() {
 *      return (
 *        <Confirm
 *          title="Title text..."
 *          text="Some content..."
 *          confirmLabel="Confirm"
 *          cancelLabel="Cancel"
 *          onConfirm={...}
 *          onCancel={...}
 *        />
 *      );
 *   }
 * }
 * ```
 */
var Confirm = (_dec = (0, _cnDecorator2.default)('tas-modal'), _dec(_class = function (_React$Component) {
  (0, _inherits3.default)(Confirm, _React$Component);

  function Confirm() {
    (0, _classCallCheck3.default)(this, Confirm);
    return (0, _possibleConstructorReturn3.default)(this, (Confirm.__proto__ || (0, _getPrototypeOf2.default)(Confirm)).apply(this, arguments));
  }

  (0, _createClass3.default)(Confirm, [{
    key: 'render',
    value: function render(bem) {
      var _this2 = this;

      var _props = this.props,
          name = _props.name,
          title = _props.title,
          text = _props.text,
          confirmLabel = _props.confirmLabel,
          cancelLabel = _props.cancelLabel,
          onConfirm = _props.onConfirm,
          onCancel = _props.onCancel,
          disabled = _props.disabled,
          hideOnControl = _props.hideOnControl;


      return _react2.default.createElement(
        _index2.default,
        {
          name: name,
          ref: function ref(_ref) {
            _this2.$modal = _ref && _ref.getWrappedInstance();
          },
          header: _react2.default.createElement(
            _Title2.default,
            { heading: 4, theme: 'custom' },
            title
          ),
          footer: _react2.default.createElement(
            'div',
            { className: bem('confirm-buttons') },
            _react2.default.createElement(
              'div',
              { className: bem('confirm') },
              _react2.default.createElement(
                _Button2.default,
                {
                  theme: 'button-link',
                  disabled: disabled,
                  onClick: function onClick(e) {
                    hideOnControl && _this2.$modal.hide();
                    onConfirm(e, _this2.$modal);
                  }
                },
                confirmLabel
              )
            ),
            _react2.default.createElement(
              'div',
              { className: bem('cancel') },
              _react2.default.createElement(
                _Button2.default,
                {
                  theme: 'button-link',
                  disabled: disabled,
                  onClick: function onClick(e) {
                    hideOnControl && _this2.$modal.hide();
                    onCancel(e, _this2.$modal);
                  }
                },
                cancelLabel
              )
            )
          ),
          onClose: onCancel
        },
        _react2.default.createElement(
          'span',
          { className: bem('confirm-text') },
          text
        )
      );
    }
  }]);
  return Confirm;
}(_react2.default.Component)) || _class);
Confirm.displayName = 'Confirm';
Confirm.propTypes = {
  title: _propTypes2.default.string,
  text: _propTypes2.default.string,
  confirmLabel: _propTypes2.default.string,
  cancelLabel: _propTypes2.default.string,
  onConfirm: _propTypes2.default.func,
  onCancel: _propTypes2.default.func,
  hideOnControl: _propTypes2.default.bool,
  disabled: _propTypes2.default.bool
};
Confirm.defaultProps = {
  title: 'Confirm',
  text: '',
  confirmLabel: 'Confirm',
  cancelLabel: 'Cancel',
  hideOnControl: false,
  disabled: false,
  onConfirm: function onConfirm() {},
  onCancel: function onCancel() {}
};
exports.default = Confirm;