'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.modal = exports.default = undefined;

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _dec2, _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _cnDecorator = require('cn-decorator');

var _cnDecorator2 = _interopRequireDefault(_cnDecorator);

var _reactRedux = require('react-redux');

var _Icon = require('../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _redux = require('./redux');

require('./index.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * ## Usage
 *
 * ```javascript
 * import Modal from '@Components/Modal';
 *
 * export default class {
 *   render() {
 *      return (
 *        <Modal
 *          header="Header"
 *          footer="Maybe some buttons..."
 *          onClose={...}
 *        >
 *          Some content...
 *        </Modal>
 *      );
 *   }
 * }
 * ```
 */
var Modal = (_dec = (0, _reactRedux.connect)(function (state, _ref) {
  var name = _ref.name;
  return {
    modal: typeof state.get === 'function' ? state.get('modal')[name] : state.modal[name]
  };
}, { hideModal: _redux.hideModal }, null, { withRef: true }), _dec2 = (0, _cnDecorator2.default)('tas-modal'), _dec(_class = _dec2(_class = function (_React$Component) {
  (0, _inherits3.default)(Modal, _React$Component);

  function Modal() {
    var _ref2;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, Modal);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref2 = Modal.__proto__ || (0, _getPrototypeOf2.default)(Modal)).call.apply(_ref2, [this].concat(args))), _this), _this.state = {
      hide: false
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(Modal, [{
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.props.hideModal(this.props.name);
    }
  }, {
    key: 'handleClose',
    value: function handleClose(e) {
      this.setState({ hide: true });
      this.props.onClose(e);
    }
  }, {
    key: 'hide',
    value: function hide() {
      this.setState({ hide: true });
    }
  }, {
    key: 'render',
    value: function render(bem) {
      var _this2 = this;

      var hide = this.state.hide;
      var _props = this.props,
          header = _props.header,
          children = _props.children,
          footer = _props.footer,
          modal = _props.modal;


      var meta = modal && modal.options || {};

      if (!modal) {
        return null;
      }

      return _react2.default.createElement(
        'div',
        {
          id: 'modal-' + modal.name,
          className: bem({ hide: hide }),
          onAnimationEnd: function onAnimationEnd() {
            hide && _this2.props.hideModal(_this2.props.name);
            _this2.setState({ hide: false });
          }
        },
        _react2.default.createElement('div', {
          className: bem('background'),
          onClick: function onClick(e) {
            return _this2.handleClose(e);
          },
          role: 'presentation'
        }),
        _react2.default.createElement(
          'section',
          { className: bem('dialog') },
          _react2.default.createElement(
            'header',
            { className: bem('header') },
            header,
            _react2.default.createElement(
              'div',
              {
                className: bem('close'),
                onClick: function onClick(e) {
                  return _this2.handleClose(e);
                },
                role: 'presentation'
              },
              _react2.default.createElement(_Icon2.default, { name: 'close', size: 14 })
            )
          ),
          _react2.default.createElement(
            'article',
            { className: bem('content') },
            _react2.default.cloneElement(children, { meta: meta })
          ),
          _react2.default.createElement(
            'footer',
            { className: bem('footer') },
            footer
          )
        )
      );
    }
  }]);
  return Modal;
}(_react2.default.Component)) || _class) || _class);
Modal.displayName = 'Modal';
Modal.propTypes = {
  name: _propTypes2.default.string.isRequired,
  onClose: _propTypes2.default.func,
  header: _propTypes2.default.any,
  children: _propTypes2.default.any,
  footer: _propTypes2.default.any
};
Modal.defaultProps = {
  onClose: function onClose() {},

  header: null,
  children: null,
  footer: null
};
exports.default = Modal;
var modal = exports.modal = function modal(name) {
  return function (ComposedComponent) {
    return (0, _reactRedux.connect)(null, function (dispatch) {
      return {
        show: dispatch((0, _redux.showModal)(name)),
        hide: dispatch((0, _redux.hideModal)(name)),
        hideAll: dispatch((0, _redux.hideAllModal)())
      };
    })(ComposedComponent);
  };
};