'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.hideAllModal = exports.hideModal = exports.showModal = undefined;

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends4 = require('babel-runtime/helpers/extends');

var _extends5 = _interopRequireDefault(_extends4);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SHOW_MODAL = '@modal/SHOW';
var HIDE_MODAL = '@modal/HIDE';
var HIDE_ALL_MODAL = '@modal/HIDE_ALL';

var showModal = exports.showModal = function showModal(name, options) {
  return {
    type: SHOW_MODAL,
    payload: { name: name, options: options }
  };
};

var hideModal = exports.hideModal = function hideModal(name) {
  return {
    type: HIDE_MODAL,
    payload: { name: name }
  };
};

var hideAllModal = exports.hideAllModal = function hideAllModal() {
  return {
    type: HIDE_ALL_MODAL,
    payload: null
  };
};

exports.default = function () {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var action = arguments[1];

  switch (action.type) {
    case SHOW_MODAL:
      return (0, _extends5.default)({}, state, (0, _defineProperty3.default)({}, action.payload.name, (0, _extends5.default)({
        show: true
      }, action.payload)));
    case HIDE_MODAL:
      return (0, _extends5.default)({}, state, (0, _defineProperty3.default)({}, action.payload.name, null));
    case HIDE_ALL_MODAL:
      return {};
    default:
      return state;
  }
};