'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _cnDecorator = require('cn-decorator');

var _cnDecorator2 = _interopRequireDefault(_cnDecorator);

var _Tabs = require('material-ui/Tabs');

var _Tabs2 = _interopRequireDefault(_Tabs);

require('./index.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * ## Usage
 *
 * ```javascript
 * import MultiTabs from '@Components/MultiTabs';
 *
 * export default class {
 *   render() {
 *     return (
 *       <MultiTabs
 *        tabs={[
 *          'first tab',
 *          'second tab',
 *        ]}
 *       >
 *        <FirstTab/>
 *        <SecondTab/>
 *       </MultiTabs>
 *     );
 *   }
 * }
 * ```
 */
var MultiTabs = (_dec = (0, _cnDecorator2.default)('multi-tabs'), _dec(_class = function (_React$Component) {
  (0, _inherits3.default)(MultiTabs, _React$Component);

  function MultiTabs() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, MultiTabs);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = MultiTabs.__proto__ || (0, _getPrototypeOf2.default)(MultiTabs)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      value: _this.props.active
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(MultiTabs, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(newProps) {
      if (this.props.active !== newProps.active) {
        this.setState({ value: newProps.active });
      }
    }
  }, {
    key: 'handleChange',
    value: function handleChange(value) {
      this.setState({ value: value });
      this.props.onChange(value);
    }
  }, {
    key: 'render',
    value: function render(bem) {
      var _this2 = this;

      var _props = this.props,
          tabs = _props.tabs,
          children = _props.children,
          defaultBorder = _props.defaultBorder,
          scrollable = _props.scrollable,
          scrollButtons = _props.scrollButtons;
      var value = this.state.value;


      return _react2.default.createElement(
        'div',
        { className: bem() },
        _react2.default.createElement(
          _Tabs2.default,
          {
            value: value,
            classes: {
              root: bem('tabs-root', { line: defaultBorder })
            },
            onChange: function onChange(e, value) {
              return _this2.handleChange(value);
            },
            scrollable: scrollable,
            scrollButtons: scrollButtons
          },
          tabs.map(function (tab, index) {
            return _react2.default.createElement(_Tabs.Tab, {
              key: index,
              disabled: tab.disabled,
              label: tab.label || tab,
              classes: {
                root: bem('tab', { disabled: tab.disabled }),
                rootInheritSelected: bem('tab', { selected: true })
              }
            });
          })
        ),
        _react2.default.Children.toArray(children)[value]
      );
    }
  }]);
  return MultiTabs;
}(_react2.default.Component)) || _class);
MultiTabs.displayName = 'MultiTabs';
MultiTabs.propTypes = {
  tabs: _propTypes2.default.arrayOf(_propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number])).isRequired,
  /**
   * Callback which will be fired when tabs change
   */
  onChange: _propTypes2.default.func,
  /**
   * Index of active tab from tabs array
   */
  active: _propTypes2.default.number,

  /**
   * Set default border to tabs
   */
  defaultBorder: _propTypes2.default.bool,
  scrollable: _propTypes2.default.bool,
  scrollButtons: _propTypes2.default.oneOf(['on', 'off', 'auto', ''])
};
MultiTabs.defaultProps = {
  onChange: function onChange() {},
  active: 0,
  defaultBorder: true,
  scrollable: false,
  scrollButtons: ''
};
exports.default = MultiTabs;