'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

require('./index.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * ## About Component
 * ## Usage
 *
 * ```javascript
 * import Paper from '@Components/Paper';
 *
 * export default class {
 *   render() {
 *     return (
 *       <Paper>
 *           <div>Hola!</div>
 *       </Paper>
 *     );
 *   }
 * }
 * ```
 */
var Paper = function (_React$PureComponent) {
  (0, _inherits3.default)(Paper, _React$PureComponent);

  function Paper() {
    (0, _classCallCheck3.default)(this, Paper);
    return (0, _possibleConstructorReturn3.default)(this, (Paper.__proto__ || (0, _getPrototypeOf2.default)(Paper)).apply(this, arguments));
  }

  (0, _createClass3.default)(Paper, [{
    key: 'render',
    value: function render() {
      var _classNames;

      var _props = this.props,
          theme = _props.theme,
          shadowType = _props.shadowType,
          children = _props.children;

      return _react2.default.createElement(
        'div',
        { className: (0, _classnames2.default)('paper', (_classNames = {}, (0, _defineProperty3.default)(_classNames, 'paper__theme-' + theme, theme), (0, _defineProperty3.default)(_classNames, 'paper_shadow_' + shadowType, shadowType), _classNames))
        },
        children
      );
    }
  }]);
  return Paper;
}(_react2.default.PureComponent);

Paper.displayName = 'Paper';
Paper.propTypes = {
  shadowType: _propTypes2.default.oneOf(['default', 'light']),
  theme: _propTypes2.default.oneOf([false, 'no-radius', 'top-border-blue'])
};
Paper.defaultProps = {
  shadowType: 'default',
  theme: false
};
exports.default = Paper;