'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _TextInput = require('../TextInput');

var _TextInput2 = _interopRequireDefault(_TextInput);

var _Eye = require('./Eye');

var _Eye2 = _interopRequireDefault(_Eye);

var _Hints = require('./Hints');

var _Hints2 = _interopRequireDefault(_Hints);

require('./index.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * ## Usage
 * ```
 * <PasswordInput
 *  label="Password"
 *  getPasswordSafetyClass={value => value % 5}
 * />
 * ```
 * ## Other Properties
 * Any other properties supplied will be spread to the TextInput element
 */
var PasswordInput = function (_React$PureComponent) {
  (0, _inherits3.default)(PasswordInput, _React$PureComponent);

  function PasswordInput() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, PasswordInput);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = PasswordInput.__proto__ || (0, _getPrototypeOf2.default)(PasswordInput)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      type: _this.props.type, // props type is a real type, while state type is a current type
      // (it can be temporary changed for password demonstration)
      isInFocus: false
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(PasswordInput, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(_ref2) {
      var type = _ref2.type;

      this.setState({ type: type });
    }
  }, {
    key: 'getPasswordSafetyClass',
    value: function getPasswordSafetyClass(passwordValue) {
      var getPasswordSafetyClass = this.props.getPasswordSafetyClass;

      if (typeof getPasswordSafetyClass !== 'function') {
        return '';
      }
      var score = getPasswordSafetyClass(passwordValue);
      var scoreMap = ['yellow', 'yellow', 'green', 'green', 'strong-green'];
      return scoreMap[score];
    }
  }, {
    key: 'changeInputType',
    value: function changeInputType(type) {
      this.setState({ type: type });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          eye = _props.eye,
          hints = _props.hints,
          rootClassName = _props.rootClassName,
          otherProps = (0, _objectWithoutProperties3.default)(_props, ['eye', 'hints', 'rootClassName']);
      var _state = this.state,
          _state$type = _state.type,
          type = _state$type === undefined ? 'password' : _state$type,
          isInFocus = _state.isInFocus;

      return _react2.default.createElement(
        'div',
        { className: (0, _classnames2.default)('password-input', rootClassName) },
        _react2.default.createElement(
          'div',
          { className: 'password-input__wrapper' },
          _react2.default.createElement(_TextInput2.default, (0, _extends3.default)({}, otherProps, {
            innerProps: {
              className: (0, _classnames2.default)('password-input__input', this.getPasswordSafetyClass(otherProps.input ? otherProps.input.value : ''))
            },
            input: (0, _extends3.default)({}, otherProps.input, {
              type: type,
              onFocus: function onFocus(e) {
                otherProps.input.onFocus(e.target.value);
                _this2.setState({ isInFocus: true });
              },
              onBlur: function onBlur(e) {
                otherProps.input.onBlur(e.target.value);
                _this2.setState({ isInFocus: false });
              }
            })
          })),
          eye && _react2.default.createElement(_Eye2.default, (0, _extends3.default)({ type: type }, { onChange: function onChange(type) {
              return _this2.changeInputType(type);
            } })),
          hints && isInFocus && _react2.default.createElement(_Hints2.default, { hints: hints })
        )
      );
    }
  }]);
  return PasswordInput;
}(_react2.default.PureComponent);

PasswordInput.displayName = 'PasswordInput';
PasswordInput.propTypes = {
  /**
   * Enable Password redaction feature
   */
  eye: _propTypes2.default.bool,
  /**
   * List of password tips texts, left it empty to disable feature
   */
  hints: _propTypes2.default.arrayOf(_propTypes2.default.string),
  /**
   * Class name of root div
   */
  rootClassName: _propTypes2.default.string,
  /**
   * Function witch return safety mark of target password from 0 to 4,
   * left it empty to disable feature
   */
  getPasswordSafetyClass: _propTypes2.default.func,

  input: _propTypes2.default.object
};
PasswordInput.defaultProps = {
  eye: true,
  hints: [],
  rootClassName: '',
  getPasswordSafetyClass: null,
  input: {
    onFocus: function onFocus() {},
    onBlur: function onBlur() {}
  }
};
exports.default = PasswordInput;