'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Radio = require('material-ui/Radio');

var _Radio2 = _interopRequireDefault(_Radio);

var _Form = require('material-ui/Form');

require('./index.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * ## Usage
 *
 * ```javascript
 * import { Field } from 'redux-form/immutable';
 * import RadioInput from '@Components/RadioInput';
 *
 * export default class {
 *   render() {
 *     return (
 *       <Field
 *          name="myRadioInput"
 *          component={RadioInput}
 *          label="Label text"
 *       />
 *     );
 *   }
 * }
 * ```
 */
var RadioInput = function (_React$Component) {
  (0, _inherits3.default)(RadioInput, _React$Component);

  function RadioInput() {
    (0, _classCallCheck3.default)(this, RadioInput);
    return (0, _possibleConstructorReturn3.default)(this, (RadioInput.__proto__ || (0, _getPrototypeOf2.default)(RadioInput)).apply(this, arguments));
  }

  (0, _createClass3.default)(RadioInput, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          label = _props.label,
          helperText = _props.helperText,
          input = _props.input,
          id = _props.id,
          disabled = _props.disabled,
          meta = _props.meta,
          checked = _props.checked;


      var error = (meta.touched || meta.visited && !meta.active || meta.submitFailed) && meta.error;

      return _react2.default.createElement(
        _Form.FormControl,
        { error: error, disabled: disabled, className: 'radio-input' },
        _react2.default.createElement(_Form.FormControlLabel, (0, _extends3.default)({}, input, {
          control: _react2.default.createElement(_Radio2.default, (0, _extends3.default)({
            id: id,
            classes: {
              default: 'radio-input__input',
              checked: 'radio-input__input_checked',
              disabled: 'radio-input__input_disabled'
            },
            checked: input.checked || checked
          }, input)),
          label: _react2.default.createElement(
            'div',
            null,
            label,
            _react2.default.createElement(
              'div',
              { className: 'radio-input__help-text' },
              helperText
            )
          )
        })),
        error && _react2.default.createElement(
          _Form.FormHelperText,
          { className: 'radio-input__help-text_error' },
          error
        )
      );
    }
  }]);
  return RadioInput;
}(_react2.default.Component);

RadioInput.displayName = 'RadioInput';
RadioInput.propTypes = {
  label: _propTypes2.default.string,
  id: _propTypes2.default.string,
  disabled: _propTypes2.default.bool,
  checked: _propTypes2.default.bool,
  helperText: _propTypes2.default.string,
  input: _propTypes2.default.object,
  meta: _propTypes2.default.object
};
RadioInput.defaultProps = {
  label: undefined,
  helperText: undefined,
  id: undefined,
  input: {},
  meta: {},
  disabled: false,
  checked: false
};
exports.default = RadioInput;