'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _cnDecorator = require('cn-decorator');

var _cnDecorator2 = _interopRequireDefault(_cnDecorator);

var _Input = require('material-ui/Input');

var _Input2 = _interopRequireDefault(_Input);

var _Menu = require('material-ui/Menu');

var _Form = require('material-ui/Form');

var _Select = require('material-ui/Select');

var _Select2 = _interopRequireDefault(_Select);

var _Progress = require('material-ui/Progress');

require('./index.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * ## Usage
 *
 * ```javascript
 * import Example from '@Components/Select';
 *
 * export default class {
 *   render() {
 *     return (
 *       <Select />
 *     );
 *   }
 * }
 * ```
 */
var Select = (_dec = (0, _cnDecorator2.default)('select'), _dec(_class = function (_React$PureComponent) {
  (0, _inherits3.default)(Select, _React$PureComponent);

  function Select() {
    (0, _classCallCheck3.default)(this, Select);
    return (0, _possibleConstructorReturn3.default)(this, (Select.__proto__ || (0, _getPrototypeOf2.default)(Select)).apply(this, arguments));
  }

  (0, _createClass3.default)(Select, [{
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      if (prevProps.meta.error && prevProps.meta.submitFailed === false && this.props.meta.submitFailed) {
        var name = this.props.input.name;


        if (!document.getElementsByClassName('text-input__input_error').length) {
          var errorField = document.getElementsByClassName('select__input_error')[0];
          var inputFromDom = errorField.getElementsByTagName('input')[0];

          if (name === inputFromDom.name) {
            var focusedField = errorField.querySelectorAll('[tabindex="0"]')[0];

            focusedField && focusedField.focus();
          }
        }
      }
    }
  }, {
    key: 'render',
    value: function render(bem) {
      var _props = this.props,
          label = _props.label,
          input = _props.input,
          innerProps = _props.innerProps,
          meta = _props.meta,
          list = _props.list,
          helperText = _props.helperText,
          id = _props.id,
          disabled = _props.disabled,
          emptyText = _props.emptyText,
          loading = _props.loading;


      var error = (meta.touched || meta.visited && !meta.active || meta.submitFailed) && meta.error;

      return _react2.default.createElement(
        _Form.FormControl,
        {
          disabled: disabled || loading,
          error: error,
          className: bem({ theme: this.props.theme, loading: loading })
        },
        _react2.default.createElement(
          _Input.InputLabel,
          {
            htmlFor: id,
            FormControlClasses: {
              root: bem('label'),
              focused: bem('label', { focused: true })
            }
          },
          label
        ),
        _react2.default.createElement(
          _Select2.default,
          (0, _extends3.default)({}, innerProps, input, {
            input: _react2.default.createElement(_Input2.default, {
              classes: {
                root: bem('input'),
                focused: bem('input', { focused: true }),
                error: bem('input', { error: true })
              },
              name: input.name,
              id: id
            }),
            onBlur: null
          }),
          emptyText && _react2.default.createElement(
            _Menu.MenuItem,
            { value: '' },
            _react2.default.createElement(
              'em',
              null,
              emptyText
            )
          ),
          list.map(function (_ref) {
            var value = _ref.value,
                label = _ref.label;
            return _react2.default.createElement(
              _Menu.MenuItem,
              { key: value + '_' + Date.now(), value: value },
              label
            );
          })
        ),
        helperText && _react2.default.createElement(
          _Form.FormHelperText,
          { className: bem('help-text') },
          helperText
        ),
        error && _react2.default.createElement(
          _Form.FormHelperText,
          { className: bem('help-text', { error: true }) },
          error
        ),
        loading && _react2.default.createElement(_Progress.LinearProgress, { classes: { root: bem('progress') }, variant: 'query' })
      );
    }
  }]);
  return Select;
}(_react2.default.PureComponent)) || _class);
Select.displayName = 'Select';
Select.propTypes = {
  label: _propTypes2.default.string,
  disabled: _propTypes2.default.bool,
  input: _propTypes2.default.object,
  innerProps: _propTypes2.default.object,
  meta: _propTypes2.default.object,
  id: _propTypes2.default.string,
  helperText: _propTypes2.default.string,
  list: _propTypes2.default.array,
  emptyText: _propTypes2.default.any,
  theme: _propTypes2.default.oneOf(['default', 'payments-form', 'autofill-form']),
  loading: _propTypes2.default.bool
};
Select.defaultProps = {
  id: undefined,
  helperText: undefined,
  emptyText: undefined,
  disabled: false,
  label: 'Label',
  input: {
    value: '',
    name: ''
  },
  meta: {},
  innerProps: {},
  list: [],
  theme: 'default',
  loading: false
};
exports.default = Select;