'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _cnDecorator = require('cn-decorator');

var _cnDecorator2 = _interopRequireDefault(_cnDecorator);

require('./index.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * ## Usage
 *
 * ```javascript
 * import Switch from '@Components/Switch';
 *
 * export default class {
 *   render() {
 *     return (
 *       <Field
 *          name="your-field-name"
 *          id="your-field-id"
 *          label="your-field-label"
 *          component={Switch}
 *       />
 *     );
 *   }
 * }
 * ```
 */
var Switch = (_dec = (0, _cnDecorator2.default)('switch'), _dec(_class = function (_React$PureComponent) {
  (0, _inherits3.default)(Switch, _React$PureComponent);

  function Switch() {
    (0, _classCallCheck3.default)(this, Switch);
    return (0, _possibleConstructorReturn3.default)(this, (Switch.__proto__ || (0, _getPrototypeOf2.default)(Switch)).apply(this, arguments));
  }

  (0, _createClass3.default)(Switch, [{
    key: 'render',
    value: function render(bem) {
      var _props = this.props,
          input = _props.input,
          id = _props.id,
          label = _props.label,
          disable = _props.disable;


      return _react2.default.createElement(
        'div',
        { className: bem({ checked: input.value, disable: disable }) },
        _react2.default.createElement('input', (0, _extends3.default)({
          type: 'checkbox',
          id: id,
          className: bem('input')
        }, input, {
          onChange: function onChange() {
            input.onChange(!input.value);
          },
          onBlur: function onBlur() {
            input.onBlur(input.value);
          }
        })),
        _react2.default.createElement('div', { className: bem('background') }),
        _react2.default.createElement('button', { className: bem('button') }),
        _react2.default.createElement(
          'label',
          { htmlFor: id, className: bem('label') },
          label
        )
      );
    }
  }]);
  return Switch;
}(_react2.default.PureComponent)) || _class);
Switch.displayName = 'Switch';
Switch.propTypes = {
  id: _propTypes2.default.string,
  label: _propTypes2.default.string,
  disable: _propTypes2.default.bool
};
Switch.defaultProps = {
  id: undefined,
  label: undefined,
  disable: false
};
exports.default = Switch;