'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Table = require('material-ui/Table');

var _Checkbox = require('../../Checkbox');

var _Checkbox2 = _interopRequireDefault(_Checkbox);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Head = function (_React$Component) {
  (0, _inherits3.default)(Head, _React$Component);

  function Head() {
    (0, _classCallCheck3.default)(this, Head);
    return (0, _possibleConstructorReturn3.default)(this, (Head.__proto__ || (0, _getPrototypeOf2.default)(Head)).apply(this, arguments));
  }

  (0, _createClass3.default)(Head, [{
    key: 'getTableCellClassName',
    value: function getTableCellClassName(key) {
      var index = this.props.columnData.findIndex(function (i) {
        return i.id === key;
      });
      return (0, _classnames2.default)('tas-table__cell', {
        'tas-table__cell_first': index === 0,
        'tas-table__cell_last': index === this.props.columnData.length - 1
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          onRequestSort = _props.onRequestSort,
          onSelectAllClick = _props.onSelectAllClick,
          order = _props.order,
          orderBy = _props.orderBy,
          withSort = _props.withSort,
          numSelected = _props.numSelected,
          rowCount = _props.rowCount,
          columnData = _props.columnData,
          withCheckboxes = _props.withCheckboxes;


      return _react2.default.createElement(
        _Table.TableHead,
        { className: 'tas-table__head' },
        _react2.default.createElement(
          _Table.TableRow,
          { className: 'tas-table__row tas-table__row_head' },
          withCheckboxes && _react2.default.createElement(
            _Table.TableCell,
            {
              className: 'tas-table__cell tas-table__cell_checkbox',
              padding: 'none'
            },
            _react2.default.createElement(_Checkbox2.default, {
              input: {
                checked: rowCount && numSelected === rowCount,
                indeterminate: numSelected > 0 && numSelected < rowCount,
                onChange: function onChange(e, all) {
                  return onSelectAllClick(e, all);
                }
              }
            })
          ),
          columnData.map(function (column) {
            return _react2.default.createElement(
              _Table.TableCell,
              {
                className: _this2.getTableCellClassName(column.id),
                padding: 'none',
                key: column.id,
                numeric: column.alignRight,
                sortDirection: orderBy === column.id ? order : false,
                style: { width: column.width }
              },
              withSort && column.orderBy ? _react2.default.createElement(
                _Table.TableSortLabel,
                {
                  active: orderBy === column.id || orderBy === column.orderBy,
                  direction: order,
                  onClick: function onClick(event) {
                    return onRequestSort({ event: event, column: column });
                  }
                },
                column.label
              ) : column.label
            );
          })
        )
      );
    }
  }]);
  return Head;
}(_react2.default.Component);

Head.displayName = 'Head';
Head.propTypes = {
  numSelected: _propTypes2.default.number.isRequired,
  onRequestSort: _propTypes2.default.func.isRequired,
  onSelectAllClick: _propTypes2.default.func.isRequired,
  order: _propTypes2.default.string.isRequired,
  orderBy: _propTypes2.default.string.isRequired,
  rowCount: _propTypes2.default.number.isRequired,
  withCheckboxes: _propTypes2.default.bool.isRequired
};
exports.default = Head;