'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _TextInput = require('../../TextInput');

var _TextInput2 = _interopRequireDefault(_TextInput);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ToolBar = function (_React$Component) {
  (0, _inherits3.default)(ToolBar, _React$Component);

  function ToolBar() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, ToolBar);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = ToolBar.__proto__ || (0, _getPrototypeOf2.default)(ToolBar)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      searchValue: '',
      visible: false,
      focused: false
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(ToolBar, [{
    key: 'handleClick',
    value: function handleClick() {
      this.searchInput.focus();
      this.setState({
        visible: true,
        focused: true
      });
    }
  }, {
    key: 'handleBlur',
    value: function handleBlur() {
      this.setState({ focused: false });
      if (!this.state.searchValue) {
        this.setState({ visible: false });
      }
    }
  }, {
    key: 'handleChangeSearchValue',
    value: function handleChangeSearchValue(_ref2) {
      var value = _ref2.target.value;

      this.setState({ searchValue: value });
      this.props.onChangeSearchValue(value);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          selectedCount = _props.selectedCount,
          mainLabel = _props.mainLabel,
          labelChosen = _props.labelChosen,
          withSearchBar = _props.withSearchBar,
          tools = _props.tools,
          innerRef = _props.innerRef;


      return _react2.default.createElement(
        'section',
        {
          ref: function ref(a) {
            innerRef(a);
          },
          className: 'tas-table__tool-bar'
        },
        selectedCount ? _react2.default.createElement(
          'section',
          { className: 'tas-table__tool-bar-content' },
          _react2.default.createElement(
            'span',
            { className: 'tas-table__cell-count' },
            ' ' + labelChosen,
            _react2.default.createElement(
              'span',
              { className: 'tas-table__cell-counter' },
              selectedCount
            )
          ),
          _react2.default.createElement(
            'div',
            { className: 'tas-table__tool-bar-tools' },
            tools
          )
        ) : _react2.default.createElement(
          'section',
          { className: this.toolBarLabelClassName },
          _react2.default.createElement(
            'section',
            { className: 'tas-table__label' },
            mainLabel
          ),
          withSearchBar && _react2.default.createElement(
            'section',
            { className: 'tas-table__search-bar' },
            _react2.default.createElement('div', {
              className: 'tas-table__search-icon',
              role: 'presentation',
              onClick: function onClick() {
                return _this2.handleClick();
              }
            }),
            _react2.default.createElement(
              'div',
              { className: 'tas-table__search-input' },
              _react2.default.createElement(_TextInput2.default, {
                input: {
                  inputRef: function inputRef(a) {
                    _this2.searchInput = a;
                  },
                  onFocus: function onFocus() {
                    return _this2.setState({ focused: true });
                  },
                  onChange: function onChange(event) {
                    return _this2.handleChangeSearchValue(event);
                  },
                  onBlur: function onBlur() {
                    return _this2.handleBlur();
                  }
                }
              })
            )
          )
        )
      );
    }
  }, {
    key: 'toolBarLabelClassName',
    get: function get() {
      return (0, _classnames2.default)('tas-table__tool-bar-label', {
        'tas-table__tool-bar-label_active': this.state.visible,
        'tas-table__tool-bar-label_focused': this.state.focused,
        'tas-table__tool-bar-label_empty': !this.props.withSearchBar && !this.props.mainLabel
      });
    }
  }]);
  return ToolBar;
}(_react2.default.Component);

ToolBar.displayName = 'ToolBar';
ToolBar.propTypes = {
  labelChosen: _propTypes2.default.string.isRequired,
  selectedCount: _propTypes2.default.number.isRequired,
  mainLabel: _propTypes2.default.string.isRequired,
  onChangeSearchValue: _propTypes2.default.func.isRequired,
  tools: _propTypes2.default.any.isRequired,
  innerRef: _propTypes2.default.func.isRequired
};
exports.default = ToolBar;