'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _from = require('babel-runtime/core-js/array/from');

var _from2 = _interopRequireDefault(_from);

var _isInteger = require('babel-runtime/core-js/number/is-integer');

var _isInteger2 = _interopRequireDefault(_isInteger);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _dec, _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _cnDecorator = require('cn-decorator');

var _cnDecorator2 = _interopRequireDefault(_cnDecorator);

var _Table = require('material-ui/Table');

var _Table2 = _interopRequireDefault(_Table);

var _Checkbox = require('../Checkbox');

var _Checkbox2 = _interopRequireDefault(_Checkbox);

var _Head = require('./Head');

var _Head2 = _interopRequireDefault(_Head);

var _Footer = require('./Footer');

var _Footer2 = _interopRequireDefault(_Footer);

var _ToolBar = require('./ToolBar');

var _ToolBar2 = _interopRequireDefault(_ToolBar);

var _CircularProgress = require('../CircularProgress');

var _CircularProgress2 = _interopRequireDefault(_CircularProgress);

require('./index.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var counter = 0;
var createData = function createData(props) {
  counter += 1;
  return (0, _extends3.default)({
    id: props.meta && props.meta.id ? props.meta.id : counter,
    visible: true
  }, props);
};

/**
 * ## Usage
 *
 * ```javascript
 * import Table from '@Components/Table';
 *
 * export default class {
 *   render() {
 *     return (
 *       <Table
 *          columnData={[
 *            {id: "col1", label:"Label1"},
 *            {id: "col2", label:"Label1"},
 *            {id: "col3", label:"Label1"},
 *          ]}
 *          rowData={[
 *            {col1: {value: "val1", rowSpan: 2}, col2: "val2", col3: "val3"},
 *            {col2: "val1", col3: "val3"},
 *          ]}
 *          labelNoSearchResult="Have no result"
 *       />
 *     );
 *   }
 * }
 * ```
 */
var Table = (_dec = (0, _cnDecorator2.default)('tas-table'), _dec(_class = function (_React$Component) {
  (0, _inherits3.default)(Table, _React$Component);

  function Table() {
    var _ref,
        _this2 = this;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, Table);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = Table.__proto__ || (0, _getPrototypeOf2.default)(Table)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      order: _this.props.order || 'asc',
      orderBy: _this.defaultOrderBy,
      selected: [],
      data: _this.props.rowData.map(createData),
      page: 0,
      rowsPerPage: _this.props.rowsPerPage
    }, _this.searchQuery = null, _this.handleSelectAllClick = function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(selectAll) {
        var selected;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                selected = selectAll ? _this.state.data.filter(function (n) {
                  return n.visible;
                }).map(function (n) {
                  return n.id;
                }) : [];
                _context.next = 3;
                return _this.setState({ selected: selected });

              case 3:

                _this.props.onSelectAll({ selectAll: selectAll, selected: _this.state.data });

              case 4:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, _this2);
      }));

      return function (_x) {
        return _ref2.apply(this, arguments);
      };
    }(), _this.handleCheckboxChange = function () {
      var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(id) {
        var selected, selectedIndex, newSelected, newData;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                selected = _this.state.selected;
                selectedIndex = selected.indexOf(id);
                newSelected = [];


                if (selectedIndex === -1) {
                  newSelected = newSelected.concat(selected, id);
                } else if (selectedIndex === 0) {
                  newSelected = newSelected.concat(selected.slice(1));
                } else if (selectedIndex === selected.length - 1) {
                  newSelected = newSelected.concat(selected.slice(0, -1));
                } else if (selectedIndex > 0) {
                  newSelected = newSelected.concat(selected.slice(0, selectedIndex), selected.slice(selectedIndex + 1));
                }

                newData = newSelected.reduce(function (target, item) {
                  return [].concat((0, _toConsumableArray3.default)(target), [_this.state.data.find(function (_ref4) {
                    var id = _ref4.id;
                    return id === item;
                  })]);
                }, []);
                _context2.next = 7;
                return _this.setState({ selected: newSelected });

              case 7:
                _context2.next = 9;
                return _this.props.onSelectOne({ selected: newData });

              case 9:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, _this2);
      }));

      return function (_x2) {
        return _ref3.apply(this, arguments);
      };
    }(), _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(Table, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var defaultOrderBy = this.props.defaultOrderBy;
      var orderBy = this.state.orderBy;


      if (defaultOrderBy) {
        this.handleRequestSort({ column: { id: orderBy, orderBy: orderBy } });
      }
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var sticky = this.props.sticky;


      if (sticky) {
        var handleScroll = function handleScroll() {
          var layoutTop = (0, _isInteger2.default)(sticky) ? sticky : 0;

          var _$tableComponent$getB = this.$tableComponent.getBoundingClientRect(),
              tableTop = _$tableComponent$getB.top,
              tableWidth = _$tableComponent$getB.width;

          if (tableTop <= layoutTop + 10) {
            this.$tableToolbar.style.width = tableWidth + 'px';

            if ((0, _isInteger2.default)(sticky)) {
              this.$tableToolbar.style.top = sticky + 'px';
              this.$tableComponent.querySelector('thead').style.top = sticky + 65 + 'px';
            }

            (0, _from2.default)(this.$tableComponent.querySelectorAll('thead th')).forEach(function (cell) {
              var _cell$getBoundingClie = cell.getBoundingClientRect(),
                  cellWidth = _cell$getBoundingClie.width;

              cell.style.width = cellWidth + 'px';
            });

            // this.$tableHiddenHeadRow.style.height = `${this.$tableComponent.querySelector('thead').getBoundingClientRect().height}px`;
            this.$tableComponent.classList.add('tas-table_sticky');
          } else {
            // this.$tableHiddenHeadRow.style.height = '0px';
            this.$tableComponent.classList.remove('tas-table_sticky');
          }
        };

        window.onscroll = handleScroll.bind(this);
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(_ref5) {
      var _this3 = this;

      var rowData = _ref5.rowData;
      var _state = this.state,
          _state$orderBy = _state.orderBy,
          orderBy = _state$orderBy === undefined ? 'details' : _state$orderBy,
          order = _state.order;

      var newData = rowData.map(createData);

      var data = !this.props.withSort ? newData : order === 'desc' ? newData.sort(function (a, b) {
        return b[orderBy] < a[orderBy] ? -1 : 1;
      }) : newData.sort(function (a, b) {
        return a[orderBy] < b[orderBy] ? -1 : 1;
      });

      var total = data.map(function (_ref6) {
        var id = _ref6.id;
        return id;
      });
      var selected = this.state.selected.filter(function (id) {
        return total.includes(id);
      });

      this.setState({ data: data, selected: selected }, function () {
        if (_this3.searchQuery) {
          _this3.handleChangeSearchValue(_this3.searchQuery);
        }
      });
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      window.onscroll = null;
    }
  }, {
    key: 'handleRequestSort',
    value: function handleRequestSort(_ref7) {
      var _ref7$column = _ref7.column,
          id = _ref7$column.id,
          orderBy = _ref7$column.orderBy;

      var order = 'desc';

      if (this.state.orderBy === id && this.state.order === 'desc') {
        order = 'asc';
      }

      var data = order === 'desc' ? this.state.data.sort(function (a, b) {
        return b[orderBy] < a[orderBy] ? -1 : 1;
      }) : this.state.data.sort(function (a, b) {
        return a[orderBy] < b[orderBy] ? -1 : 1;
      });

      this.setState({ data: data, order: order, orderBy: id });
      this.props.onChangeSort({ data: data, order: order, orderBy: id });
    }
  }, {
    key: 'handleChangePage',
    value: function handleChangePage(page) {
      this.props.onChangePage({
        current: this.state.page,
        next: page
      });
      this.setState({ page: page });
    }
  }, {
    key: 'handleChangeRowsPerPage',
    value: function handleChangeRowsPerPage(_ref8) {
      var value = _ref8.target.value;

      this.props.onChangeRowsPerPage({
        current: this.state.rowsPerPage,
        next: value
      });
      this.setState({ rowsPerPage: value });
    }
  }, {
    key: 'handleChangeSearchValue',
    value: function handleChangeSearchValue(value) {
      var _this4 = this;

      var newData = [];
      if (value.length >= this.props.searchStartFrom) {
        newData = this.state.data.map(function (item) {
          return (0, _extends3.default)({}, item, {
            visible: _this4.props.keysForSearch.some(function (key) {
              if (key in item) {
                return item[key].toString().toLowerCase().indexOf(value.toLowerCase()) !== -1;
              }
              return true;
            })
          });
        });
      } else {
        newData = this.state.data.map(function (item) {
          return (0, _extends3.default)({}, item, { visible: true });
        });
      }

      this.searchQuery = value;

      this.setState({ data: newData });
    }
  }, {
    key: 'render',
    value: function render(bem) {
      var _this5 = this;

      var _props = this.props,
          columnData = _props.columnData,
          withPagination = _props.withPagination,
          rowsPerPageOptions = _props.rowsPerPageOptions,
          withCheckboxes = _props.withCheckboxes,
          withSort = _props.withSort,
          withHover = _props.withHover,
          mainLabel = _props.mainLabel,
          labelNoSearchResult = _props.labelNoSearchResult,
          labelChosen = _props.labelChosen,
          labelRowsPerPage = _props.labelRowsPerPage,
          withSearchBar = _props.withSearchBar,
          fixed = _props.fixed,
          isPreload = _props.isPreload,
          toolsBar = _props.toolsBar,
          count = _props.count,
          currentPage = _props.currentPage;
      var _state2 = this.state,
          data = _state2.data,
          order = _state2.order,
          orderBy = _state2.orderBy,
          selected = _state2.selected,
          rowsPerPage = _state2.rowsPerPage,
          page = _state2.page;

      var visibleRowsCount = data.filter(function (item) {
        return item.visible;
      }).length;
      var emptyRowsCount = rowsPerPage - Math.min(rowsPerPage, visibleRowsCount - page * rowsPerPage); // eslint-disable-line max-len
      var colSpan = withCheckboxes ? columnData.length + 1 : columnData.length;
      var haveVisibleRows = data.some(function (item) {
        return item.visible;
      });

      return _react2.default.createElement(
        'section',
        {
          ref: function ref(a) {
            _this5.$tableComponent = a;
          },
          className: bem({ theme: this.props.theme })
        },
        _react2.default.createElement(_ToolBar2.default, {
          innerRef: function innerRef(a) {
            _this5.$tableToolbar = a;
          },
          labelChosen: labelChosen,
          onChangeSearchValue: function onChangeSearchValue(value) {
            return _this5.handleChangeSearchValue(value);
          },
          mainLabel: mainLabel,
          selectedCount: selected.length,
          withSearchBar: withSearchBar,
          tools: toolsBar
        }),
        _react2.default.createElement(
          _Table2.default,
          { className: bem('table', { fixed: fixed }) },
          _react2.default.createElement(_Head2.default, {
            numSelected: selected.length,
            order: order,
            orderBy: orderBy,
            onSelectAllClick: function onSelectAllClick(event, selectAll) {
              return _this5.handleSelectAllClick(selectAll);
            },
            onRequestSort: function onRequestSort(data) {
              return _this5.handleRequestSort(data);
            },
            rowCount: data.length,
            columnData: columnData,
            withCheckboxes: withCheckboxes,
            withSort: withSort
          }),
          _react2.default.createElement(
            'thead',
            { style: { visibility: 'hidden' } },
            _react2.default.createElement(
              'tr',
              {
                className: bem('row', { hidden: true })
                // ref={(a) => {
                //   this.$tableHiddenHeadRow = a;
                // }}
              },
              withCheckboxes && _react2.default.createElement('th', null),
              columnData.map(function (column) {
                return _react2.default.createElement('th', { key: column.id });
              })
            )
          ),
          !isPreload ? _react2.default.createElement(
            _Table.TableBody,
            null,
            haveVisibleRows ? this.dataWithPagination.map(function (item) {
              return _react2.default.createElement(
                _Table.TableRow,
                {
                  hover: withHover,
                  key: item.id,
                  className: bem('row', { body: true, 'no-hover': !_this5.props.withHover })
                },
                withCheckboxes && _react2.default.createElement(
                  _Table.TableCell,
                  {
                    padding: 'none',
                    className: bem('cell', { checkbox: true })
                  },
                  _react2.default.createElement(_Checkbox2.default, {
                    input: {
                      checked: _this5.state.selected.indexOf(item.id) !== -1,
                      onChange: function onChange() {
                        return _this5.handleCheckboxChange(item.id);
                      }
                    }
                  })
                ),
                columnData.map(function (i) {
                  return i.id;
                }).filter(function (key) {
                  return item[key];
                }).map(function (key, index) {
                  return _react2.default.createElement(
                    _Table.TableCell,
                    {
                      key: key,
                      className: bem('cell', { first: index === 0, last: index === columnData.length - 1 }),
                      numeric: columnData.find(function (i) {
                        return i.id === key;
                      }).alignRight,
                      padding: 'none',
                      rowSpan: item[key].rowSpan || 1,
                      onClick: function onClick() {
                        return _this5.props.onRowClick(item);
                      }
                    },
                    item[key].rowSpan || item[key].colSpan ? item[key].value : item[key]
                  );
                })
              );
            }) : _react2.default.createElement(
              _Table.TableRow,
              { style: withPagination ? { height: 49 * emptyRowsCount } : {} },
              _react2.default.createElement(
                _Table.TableCell,
                { colSpan: colSpan, style: { verticalAlign: 'middle' } },
                _react2.default.createElement(
                  'section',
                  { className: bem('no-search-result') },
                  _react2.default.createElement('div', { className: bem('no-search-icon') }),
                  labelNoSearchResult
                )
              )
            ),
            withPagination && data.length > 0 && emptyRowsCount > 0 && haveVisibleRows && _react2.default.createElement(
              _Table.TableRow,
              { style: { height: 49 * emptyRowsCount } },
              _react2.default.createElement(_Table.TableCell, { colSpan: colSpan })
            )
          ) : _react2.default.createElement(
            _Table.TableBody,
            null,
            _react2.default.createElement(
              _Table.TableRow,
              { style: withPagination ? { height: 49 * rowsPerPage } : {} },
              _react2.default.createElement(
                _Table.TableCell,
                { colSpan: colSpan, style: { verticalAlign: 'middle' } },
                _react2.default.createElement(_CircularProgress2.default, { isPreload: true })
              )
            )
          ),
          withPagination && data.length > 0 && _react2.default.createElement(_Footer2.default, {
            colSpan: colSpan,
            count: count || visibleRowsCount,
            labelRowsPerPage: labelRowsPerPage,
            rowsPerPage: rowsPerPage,
            rowsPerPageOptions: rowsPerPageOptions,
            page: currentPage || page,
            onChangePage: function onChangePage(event, page) {
              return _this5.handleChangePage(page);
            },
            onChangeRowsPerPage: function onChangeRowsPerPage(event) {
              return _this5.handleChangeRowsPerPage(event);
            }
          })
        )
      );
    }
  }, {
    key: 'defaultOrderBy',
    get: function get() {
      var _props2 = this.props,
          defaultOrderBy = _props2.defaultOrderBy,
          columnData = _props2.columnData,
          withSort = _props2.withSort;


      if (withSort) {
        return defaultOrderBy || columnData.find(function (item) {
          return item.orderBy;
        }).orderBy;
      }

      return '';
    }
  }, {
    key: 'dataWithPagination',
    get: function get() {
      var _state3 = this.state,
          data = _state3.data,
          rowsPerPage = _state3.rowsPerPage,
          page = _state3.page;


      if (this.props.withPagination) {
        return data.filter(function (item) {
          return item.visible;
        }).slice(page * rowsPerPage, page * rowsPerPage + rowsPerPage);
      }

      return data.filter(function (item) {
        return item.visible;
      });
    }
  }]);
  return Table;
}(_react2.default.Component)) || _class);
Table.displayName = 'Table';
Table.propTypes = {
  /** An array of data from which head of table constructed */
  columnData: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    /** name of property from rowData for column constructing */
    id: _propTypes2.default.string.isRequired,
    /** name of property from rowData for column sorting */
    orderBy: _propTypes2.default.string,
    /** align text at column to right side, like 'numeric' style */
    alignRight: _propTypes2.default.bool,
    /** visible column name */
    label: _propTypes2.default.any.isRequired,
    /** width of column */
    width: _propTypes2.default.string
  })).isRequired,
  rowData: _propTypes2.default.array.isRequired,
  /** the array of properties that will be searched */
  keysForSearch: _propTypes2.default.array,
  /** main table label */
  mainLabel: _propTypes2.default.any,
  /** callback triggered for change page, return current page and next page */
  onChangePage: _propTypes2.default.func,
  /** callback triggered for change count of rows per page, return current count and next count */
  onChangeRowsPerPage: _propTypes2.default.func,
  /** callback triggered for column sort, return sorted data, column name and order */
  onChangeSort: _propTypes2.default.func,
  /** callback triggered for click on the row, return row data */
  onRowClick: _propTypes2.default.func,
  /** callback triggered for all rows select, return 'true' or 'false' */
  onSelectAll: _propTypes2.default.func,
  /** callback triggered for one row select, return data of all selected rows */
  onSelectOne: _propTypes2.default.func,
  /** count of rows per page, for pagination */
  rowsPerPage: _propTypes2.default.number,
  /** count of rows per page for user select, for pagination */
  rowsPerPageOptions: _propTypes2.default.array,
  /** position at string from which search start, for search */
  searchStartFrom: _propTypes2.default.number,
  theme: _propTypes2.default.oneOf(['default', 'payments-table']),
  /** enabling pagination footer, for pagination */
  withPagination: _propTypes2.default.bool,
  /** enabling checkboxes */
  withCheckboxes: _propTypes2.default.bool,
  /** enabling hover effect on row */
  withHover: _propTypes2.default.bool,
  /** enabling sortable */
  withSort: _propTypes2.default.bool,
  /** enabling search bar */
  withSearchBar: _propTypes2.default.bool,
  /** label "Транзакцій на сторінку" */
  labelRowsPerPage: _propTypes2.default.string,
  /** label "XX транзакцій обрано" */
  labelChosen: _propTypes2.default.string,
  /** label "Збігів не знайдено" */
  labelNoSearchResult: _propTypes2.default.string,
  /** set table-layout fixed  */
  fixed: _propTypes2.default.bool,
  isPreload: _propTypes2.default.bool,
  toolsBar: _propTypes2.default.any,
  order: _propTypes2.default.oneOf(['asc', 'desc']),
  count: _propTypes2.default.number,
  currentPage: _propTypes2.default.number,
  defaultOrderBy: _propTypes2.default.string,
  sticky: _propTypes2.default.oneOfType([_propTypes2.default.bool, _propTypes2.default.number])
};
Table.defaultProps = {
  onRowClick: function onRowClick() {},
  onSelectAll: function onSelectAll() {},
  onSelectOne: function onSelectOne() {},
  onChangePage: function onChangePage() {},
  onChangeRowsPerPage: function onChangeRowsPerPage() {},
  onChangeSort: function onChangeSort() {},
  rowsPerPage: 5,
  rowsPerPageOptions: [5, 10, 25],
  searchStartFrom: 3,
  theme: 'default',
  withPagination: false,
  withCheckboxes: false,
  withHover: false,
  withSort: false,
  withSearchBar: false,
  keysForSearch: [],
  mainLabel: '',
  labelRowsPerPage: '',
  labelChosen: '',
  labelNoSearchResult: '',
  fixed: false,
  isPreload: false,
  toolsBar: '',
  order: 'asc',
  defaultOrderBy: '',
  count: undefined,
  currentPage: undefined,
  sticky: false
};
exports.default = Table;