'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _cnDecorator = require('cn-decorator');

var _cnDecorator2 = _interopRequireDefault(_cnDecorator);

var _Input = require('material-ui/Input');

var _Input2 = _interopRequireDefault(_Input);

var _Form = require('material-ui/Form');

var _Progress = require('material-ui/Progress');

var _Icon = require('../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

require('./index.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * ## Usage
 *
 * ```javascript
 * import { Field } from 'redux-form/immutable';
 * import TextInput from '@Components/TextInput';
 *
 * export default class {
 *   render() {
 *     return (
 *       <Field
 *          name="myInput"
 *          component={TextInput}
 *          label="Label text"
 *       />
 *     );
 *   }
 * }
 * ```
 */
var TextInput = (_dec = (0, _cnDecorator2.default)('text-input'), _dec(_class = function (_React$Component) {
  (0, _inherits3.default)(TextInput, _React$Component);

  function TextInput() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, TextInput);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = TextInput.__proto__ || (0, _getPrototypeOf2.default)(TextInput)).call.apply(_ref, [this].concat(args))), _this), _this.inputName = _this.props.randomName ? Math.random().toString(32).substr(2, 10) : undefined, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(TextInput, [{
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      if (prevProps.meta.error && prevProps.meta.submitFailed === false && this.props.meta.submitFailed) {
        var _props = this.props,
            inputProps = _props.inputProps,
            input = _props.input;


        var name = this.inputName || input.name || inputProps.name;

        var inputFromDom = document.getElementsByClassName('text-input__input_error')[0].getElementsByTagName('input')[0];

        if (name === inputFromDom.name) {
          inputFromDom && inputFromDom.focus();
        }
      }
    }
  }, {
    key: 'render',
    value: function render(bem) {
      var _props2 = this.props,
          label = _props2.label,
          input = _props2.input,
          autoFocus = _props2.autoFocus,
          innerProps = _props2.innerProps,
          prefix = _props2.prefix,
          helperText = _props2.helperText,
          id = _props2.id,
          disabled = _props2.disabled,
          suffix = _props2.suffix,
          meta = _props2.meta,
          multiline = _props2.multiline,
          rows = _props2.rows,
          rowsMax = _props2.rowsMax,
          inputComponent = _props2.inputComponent,
          inputProps = _props2.inputProps,
          loading = _props2.loading;


      var error = (meta.touched || meta.visited && !meta.active || meta.submitFailed || !!meta.initial && !!input.value) && meta.error;

      return _react2.default.createElement(
        'section',
        { className: bem({ theme: this.props.theme, loading: loading }) },
        prefix && _react2.default.createElement(
          'div',
          { className: bem('prefix') },
          _react2.default.createElement(
            'span',
            null,
            prefix
          )
        ),
        _react2.default.createElement(
          _Form.FormControl,
          { error: error, className: bem('control', { error: error }) },
          _react2.default.createElement(
            _Input.InputLabel,
            {
              htmlFor: id,
              error: error,
              FormControlClasses: {
                root: bem('label'),
                focused: bem('label', { focused: true }),
                error: bem('label', { error: true })
              },
              classes: {
                shrink: bem('label', { shrink: true })
              }
            },
            label
          ),
          _react2.default.createElement(_Input2.default, (0, _extends3.default)({
            multiline: multiline,
            rows: rows,
            rowsMax: rowsMax,
            autoFocus: autoFocus,
            error: error || undefined,
            disabled: disabled || loading,
            id: id,
            inputComponent: inputComponent,
            inputProps: (0, _extends3.default)({}, inputProps, {
              name: this.inputName || input.name || inputProps.name
            }),
            classes: {
              root: bem('input'),
              focused: bem('input', { focused: true }),
              error: bem('input', { error: true })
            }
          }, innerProps, input)),
          _react2.default.createElement(
            'span',
            { className: bem('icon') },
            _react2.default.createElement(_Icon2.default, { name: 'edit', size: '14' })
          )
        ),
        suffix && _react2.default.createElement(
          'div',
          { className: bem('suffix') },
          _react2.default.createElement(
            'span',
            null,
            suffix
          )
        ),
        helperText && _react2.default.createElement(
          _Form.FormHelperText,
          { className: bem('help-text') },
          helperText
        ),
        error && _react2.default.createElement(
          _Form.FormHelperText,
          { className: bem('help-text', { error: true }) },
          error
        ),
        loading && _react2.default.createElement(_Progress.LinearProgress, { classes: { root: bem('progress') }, variant: 'query' })
      );
    }
  }]);
  return TextInput;
}(_react2.default.Component)) || _class);
TextInput.displayName = 'TextInput';
TextInput.propTypes = {
  label: _propTypes2.default.string,
  disabled: _propTypes2.default.bool,
  prefix: _propTypes2.default.string,
  suffix: _propTypes2.default.string,
  input: _propTypes2.default.object,
  autoFocus: _propTypes2.default.bool,
  innerProps: _propTypes2.default.object,
  meta: _propTypes2.default.object,
  id: _propTypes2.default.string,
  helperText: _propTypes2.default.string,
  multiline: _propTypes2.default.bool,
  rows: _propTypes2.default.number,
  rowsMax: _propTypes2.default.number,
  inputComponent: _propTypes2.default.func,
  randomName: _propTypes2.default.bool,
  inputProps: _propTypes2.default.object,
  theme: _propTypes2.default.oneOf(['default', 'payments-form', 'payments-form-numbers', 'autofill-form']),
  loading: _propTypes2.default.bool
};
TextInput.defaultProps = {
  autoFocus: false,
  disabled: false,
  label: undefined,
  prefix: undefined,
  suffix: undefined,
  helperText: undefined,
  id: undefined,
  inputComponent: undefined,
  innerProps: {},
  inputProps: {},
  input: {},
  meta: {},
  multiline: false,
  rows: 1,
  rowsMax: 1,
  theme: 'default',
  randomName: false,
  loading: false
};
exports.default = TextInput;