'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _styles = require('material-ui/styles');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _colors = require('material-ui/colors');

var _colors2 = require('./colors');

var _colors3 = _interopRequireDefault(_colors2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var theme = (0, _styles.createMuiTheme)({
  palette: {
    error: _colors.red
  },
  overrides: {
    MuiButton: {},
    FormHelperText: {
      error: { color: _colors3.default.ERROR_RED }
    },
    MuiInput: {
      root: {
        '&:after': {
          backgroundColor: _colors3.default.MAIN_BLUE + ' !important'
        },
        '&:before': {
          backgroundColor: _colors3.default.MAIN_GRAY + ' !important',
          height: 1 + 'px !important'
        }
      },
      error: {
        '&:after': {
          backgroundColor: _colors3.default.ERROR_RED + ' !important'
        }
      }
    },
    MuiTabIndicator: {
      root: {
        backgroundColor: _colors3.default.MAIN_RED + ' !important',
        height: 3
      }
    },
    MuiTabs: {
      root: {
        position: 'relative',
        '&:before': {
          content: '""',
          position: 'absolute',
          bottom: 0,
          left: 0,
          height: 3,
          width: '100%',
          backgroundColor: '#d8d8d8'

        }
      }
    },
    MuiTab: {
      root: {
        flex: 1,
        maxWidth: 'auto'
      }
    }
  }
});

var ThemeProvider = function (_React$PureComponent) {
  (0, _inherits3.default)(ThemeProvider, _React$PureComponent);

  function ThemeProvider() {
    (0, _classCallCheck3.default)(this, ThemeProvider);
    return (0, _possibleConstructorReturn3.default)(this, (ThemeProvider.__proto__ || (0, _getPrototypeOf2.default)(ThemeProvider)).apply(this, arguments));
  }

  (0, _createClass3.default)(ThemeProvider, [{
    key: 'render',
    value: function render() {
      var children = this.props.children;


      return _react2.default.createElement(
        _styles.MuiThemeProvider,
        { theme: theme },
        children
      );
    }
  }]);
  return ThemeProvider;
}(_react2.default.PureComponent);

ThemeProvider.displayName = 'ThemeProvider';
ThemeProvider.propTypes = {
  children: _propTypes2.default.element.isRequired
};
exports.default = ThemeProvider;