'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Typography = require('material-ui/Typography');

var _Typography2 = _interopRequireDefault(_Typography);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

require('./index.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * ## About Component
 * Title element supports classic html heading system, like h1-h6, with
 * paragraph property, as modern display property, with display property.
 * ## Usage
 *
 * ```javascript
 * import Title from '@Components/Title';
 *
 * export default class {
 *   render() {
 *     return (
 *       <Title heading={2}>Hola!</Title> {# is equivalent to <h2> #}
 *     );
 *   }
 * }
 * ```
 * ## Other Properties
 * Any other properties supplied will be spread to the *material-ui* [Typography component](https://material-ui-next.com/api/typography/)
 */
var Title = function (_React$PureComponent) {
  (0, _inherits3.default)(Title, _React$PureComponent);

  function Title() {
    (0, _classCallCheck3.default)(this, Title);
    return (0, _possibleConstructorReturn3.default)(this, (Title.__proto__ || (0, _getPrototypeOf2.default)(Title)).apply(this, arguments));
  }

  (0, _createClass3.default)(Title, [{
    key: 'render',
    value: function render() {
      var _classNames;

      var _props = this.props,
          theme = _props.theme,
          heading = _props.heading,
          display = _props.display,
          className = _props.className,
          otherProps = (0, _objectWithoutProperties3.default)(_props, ['theme', 'heading', 'display', 'className']);

      return _react2.default.createElement(_Typography2.default, (0, _extends3.default)({
        className: (0, _classnames2.default)('MuiTypography-heading', 'MuiTypography-heading__theme_' + theme, (_classNames = {}, (0, _defineProperty3.default)(_classNames, className, className), (0, _defineProperty3.default)(_classNames, 'MuiTypography-h' + heading, heading), _classNames)),
        type: display ? 'display' + display : heading && 'headline',
        component: heading ? 'h' + heading : undefined
      }, otherProps));
    }
  }]);
  return Title;
}(_react2.default.PureComponent);

Title.displayName = 'Title';
Title.propTypes = {
  /**
   * Corresponds to native html headings, like <h1>, <h2> ... <h6>
   */
  heading: _propTypes2.default.oneOf([1, 2, 3, 4, 5, 6]),
  /**
   * Corresponds to bootstrap's modern css headings
   */
  display: _propTypes2.default.oneOf([1, 2, 3, 4]),
  theme: _propTypes2.default.oneOf(['default', 'custom'])
};
Title.defaultProps = {
  heading: undefined,
  display: undefined,
  theme: 'default'
};
exports.default = Title;